' ****************
' ****************
' *   TS12.BAS   * Time Series analysis program with
' **************** Multi-frequency FOURIER transform
' **************** G Foster      1996 DEC 29
' $DYNAMIC
' NOTE: command line to compile is QB TS /AH /L MIXED
' NOTE: command line to compile is QB TS /AH /L MIXED
    DEFDBL D
    DEFLNG L
    DEFINT N
    ' =============================================
    ' = SUBROUTINES for using the MICROSOFT MOUSE =
    ' =============================================
    DECLARE SUB MOUSE (M1%, M2%, m3%, m4%)
    DECLARE SUB MOUSEHIDE ()
    DECLARE SUB MOUSENOW (LBUT%, RBUT%, MBUT%, XM%, YM%)
    DECLARE SUB MOUSESHOW ()
    ' =======================
    ' = subroutines for ZAP =
    ' =======================
    DECLARE SUB AVERAGE ()
    DECLARE SUB BREAKOUT ()
    DECLARE SUB EDIT (NTYPE)
    DECLARE SUB GETFREQ ()
    DECLARE SUB GETNAME (ZZ$, NGETFLAG)
    DECLARE SUB GETRESP (ZZ$)
    DECLARE SUB KOPYRITE ()
    DECLARE SUB LIMITS (NTYPE)
    DECLARE SUB LOADRAW ()
    DECLARE SUB LOGNOW ()
    DECLARE SUB MARKER ()
    DECLARE SUB MATCHUP (NLX, NLY)
    DECLARE SUB MATCHZZ (NL1, NL2, NT)
    DECLARE SUB MATINV ()
    DECLARE SUB PARSEREC (AREC$, FEEL$)
    DECLARE SUB POINTID ()
    DECLARE SUB POLYDERIV (DTIME, DV1, DV2, DV3)
    DECLARE SUB POLYFIT ()              ' fit a polynomial
    DECLARE SUB POLYMAST ()             ' polynomial master routine
    DECLARE SUB PROJECT ()
    DECLARE SUB PROMPT (LABL$)
    DECLARE SUB RESOLVE (DDR, DDP)
    DECLARE SUB SETLIMIT ()
    DECLARE SUB SHOWRAW ()
    DECLARE SUB SMOOTH (DTIME, DMAG)    ' compute smoothed value
    DECLARE SUB STATCOMP ()
    DECLARE SUB ZOOMVIEW ()
    ' ====================================
    ' = subroutines for FOURIER analysis =
    ' ====================================
    DECLARE SUB DCDFT ()
    DECLARE SUB FFT (FF)
    DECLARE SUB SETGRAPH (XLO, XHI, YLO, YHI, XTIC)
    DECLARE SUB SHOWBEST ()
    DECLARE SUB TABLIT ()
    ' ====================
    ' = COMMON variables =
    ' ====================
    ' ============================
    ' = 1st: should be constants =
    ' ============================
    COMMON SHARED BACK$, BARRY$, CR$, CTLA$, CTRA$
    COMMON SHARED DARR$, DELT$, DPAG$, EEND$, ESC$
    COMMON SHARED F1$, F2$, F3$, F4$, F5$
    COMMON SHARED F6$, F7$, F8$, F9$, F10$, F11$
    COMMON SHARED HOME$, INSR$, LARR$, RARR$, TAAB$, UARR$, UPAG$
    ' ===============
    ' = 2nd: others =
    ' ===============
    COMMON SHARED DAMP, DAMP2, DANGCUT, DAVE
    COMMON SHARED DFPOW, DFOURAMP2, DPOWER
    COMMON SHARED DT0, DTAVE, DTSCALE, DTSIG, DTVAR, DTZERO
    COMMON SHARED DSIG, DVAR
    COMMON SHARED DWEIGHT, DXOUT
    COMMON SHARED NBIAS, NFRE, NPOLY
    ' ============================
    ' = from previous program TS =
    ' ============================
    COMMON SHARED FILLY$, FIN$, FLOG$
    COMMON SHARED FMT2$, FOUT$, FOVR$, FTMP$, FVAL$
    COMMON SHARED JDA$, JDB$
    COMMON SHARED KSEL$
    COMMON SHARED MA, MB, MAGMARK, MAGSPAN
    COMMON SHARED MFLAG%, MCUR, MHIGH, MLOW, MPUT
    COMMON SHARED MAZOOM, MBZOOM
    COMMON SHARED NACTUAL
    COMMON SHARED NBINS, NBOTTOM, NBRAKE, NDIGT
    COMMON SHARED NDIM, NDIM2, NEGF
    COMMON SHARED NLEFT, NLOLIM, NOCOL, NXCOL, NPARSEOK
    COMMON SHARED NRIGHT, NTCOL, NTHIS, NTOP
    COMMON SHARED NUMACT, NUMRAW, NUMRED, NUPLIM, NZOOM
    COMMON SHARED ROOT$
    COMMON SHARED TCUR, TLOLIM, TMARK
    COMMON SHARED TOFF, TOFFL, TPUT, TRESOLV, TSIZE
    COMMON SHARED TUPLIM, TUPLIMIT
    COMMON SHARED TLOZOOM, TUPZOOM
    COMMON SHARED XLEFT, XRIGHT
    COMMON SHARED XMOUSE AS INTEGER, YMOUSE AS INTEGER
    COMMON SHARED YBOTTOM, YLOG$, YTOP
    COMMON SHARED DLAMP, DLLAMP, DLNU, DLPER, DLPOWER
    ' =============
    ' = constants =
    ' =============
    CONST NSIZ = 8000                   ' size of RAW data arrays
    ' $$GF CONST NSIZ = 2048                   ' temporary (for debugging)
    CONST NMAXDIM = 50
    CONST BL$ = " ", NUL$ = "", DOT$ = "."
    CONST NOOBS$ = "    "
    CONST YES$ = "Y", NO$ = "N"
    CONST FMT$ = " #####.####"
    CONST FREQFORM$ = "####.#########"
    CONST JDFORM$ = "#######.####"
    CONST NBEST = 20
    CONST TWOPI = 6.283185307179586#
    CONST TENLOG = .434294481#
    CONST NOFF = 1, NON = 4             ' colors for JD off, on areas
    CONST NX0 = 30, NX1 = 610           ' left, right plot area limits
    CONST NY0 = 40, NY1 = 220           ' top, bottom plot area limits
    CONST NWIDE = 580, NTALL = 180
    CONST NXALL = 639, NYALL = 250
    CONST GOOD = 14, BAD = 12           ' colors for good, bad data
    CONST ARROW$ = "===> "
    ' =====================
    ' = basic data arrays =
    ' =====================
    DIM SHARED WVEC(NSIZ)               ' statistical weight
    DIM SHARED TVEC(NSIZ)               ' time
    DIM SHARED XVEC(NSIZ)               ' x
    ' DIM SHARED YVEC(NSIZ)               ' y
    ' DIM SHARED ZVEC(NSIZ)               ' z
    DIM SHARED NFIT(NSIZ)               ' # in fitted curve average
    DIM SHARED TFIT(NSIZ)
    DIM SHARED XFIT(NSIZ)               ' fitted curve
    DIM SHARED SFIT(NSIZ)
    ' DIM SHARED RVEC(NSIZ)               ' residuals
    DIM SHARED OBS(NSIZ) AS STRING * 4  ' observer I.D.
    ' ====================================
    ' = matrix and vector for projection =
    ' ====================================
    DIM SHARED DMAT(NMAXDIM, NMAXDIM)   ' matrix
    DIM SHARED DVEC(NMAXDIM)            ' covariant vector
    DIM SHARED DCOEF(NMAXDIM)           ' contravariant vector
    DIM SHARED OBIAS(NMAXDIM) AS STRING * 4 ' observers to bias
    ' =================
    ' = screen images =
    ' =================
    DIM SHARED NYELLOW(53) AS INTEGER   ' yellow cursor
    ' ======================================
    ' = Fourier arrays: freq., per., ampl. =
    ' ======================================
    DIM SHARED DGNU(NBEST), DGPER(NBEST), DGPOWER(NBEST)
    DIM SHARED DFRE(NBEST)              ' frequencies to test
    ' ==============
    ' = BLUE CROSS =
    ' ============== max =  53      size =  54
    DATA  13, 13, 2, 2, 0, 2, 2, 2, 0, 2
    DATA  2, 2, 0, 2, 2, 2, 0, 2, 0, 0
    DATA  0, 0, 0, 0, 0, 0, 30960, 30960, 0, 30960
    DATA  0, 0, 0, 0, 0, 0, 0, 0, 2, 2
    DATA  0, 2, 2, 2, 0, 2, 2, 2, 0, 2
    DATA  2, 2, 0, 2
    ' ===================================
    ' = binary string to define cursor$ =
    ' ===================================
    DATA 7, 7, 127, 252, 127, 252, 127, 252, 127, 252
    DATA 127, 252, 127, 252, 128, 3, 128, 3, 128, 3
    DATA 127, 252, 127, 252, 127, 252, 127, 252, 127, 252
    DATA 127, 252, 255, 255, 0, 0, 0, 1, 0, 1
    DATA 0, 1, 0, 1, 0, 0, 0, 0, 60, 120
    DATA 0, 0, 0, 0, 0, 1, 0, 1, 0, 1
    DATA 0, 1, 0, 0, 0, 0
    ' =========   =========   =========
    ' = begin =   = begin =   = begin =
    ' =========   =========   =========
    KOPYRITE                            ' initialize everything
    ON ERROR GOTO MISTAKEN
    NTEXT = 0
    FOVR$ = "TXYZ.TXT"
OVERFILE:
    NEGF = 0
    OPEN "I", 11, FOVR$
    CLOSE 11
    IF NEGF < 0 THEN
        NTEXT = -1
        SHELL "COPY C:\AAVSOPRG\TXYZ.TXT"
        NEGF = 0
        OPEN "I", 11, FOVR$
        CLOSE 11
        IF NEGF < 0 THEN
            NTEXT = 0
        END IF
    END IF
    LOCATE 19, 1
    KSEL$ = F1$
    GOTO HITIT
MAINLOOP:
    ' ====================
    ' = get user command =
    ' ====================
    DO
        PROMPT "MAIN"
        LOCATE 23, 44
        FOR N = 1 TO NBIAS: PRINT OBIAS(N); : NEXT N
NOPROMPT:
        MOUSESHOW                   ' show the mouse
        DO                          ' detect mouse state
            MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
            IF XMOUSE <> NLASTX OR YMOUSE <> NLASTY THEN
                NLASTX = XMOUSE: NLASTY = YMOUSE
                TCUR = PMAP(XMOUSE, 2): MCUR = PMAP(YMOUSE, 3)
                LOCATE 21, 46
                DTIME = DT0 + TCUR
                PRINT USING JDFORM$; DTIME;
                PRINT USING FMT$; MCUR;
                IF TMARK > 0 THEN
                    DTIME = TCUR - TMARK
                    MOFF = MCUR - MAGMARK
                    LOCATE 22, 46
                    PRINT USING JDFORM$; DTIME;
                    PRINT USING FMT$; MOFF;
                END IF
            END IF
        LOOP UNTIL KSEL$ <> NUL$ OR LBUT% < 0 OR RBUT% < 0 OR MBUT% < 0
        MOUSEHIDE
HITIT:
        SELECT CASE KSEL$
            ' --------------------------
            CASE ESC$
                LOCATE 19, 1: PRINT "Exit? N          "
                LOCATE 19, 8: GETRESP ZZ$
                IF ZZ$ = YES$ THEN
                    GOTO ALLDUN
                END IF
            ' --------------------------
            CASE F1$                    ' load RAW data
                CLS 2
GETFIN:
                ON ERROR GOTO 0
                PRINT "Data file = "; FIN$
                LOCATE CSRLIN - 1, 13
                GETNAME FIN$, 0
                IF FIN$ <> ESC$ AND FIN$ <> NUL$ THEN
                    ON ERROR GOTO NOSUCH
                    OPEN "I", 11, FIN$
                    CLOSE 11
                    ON ERROR GOTO 0
                    LOADRAW
                END IF
            ' --------------------------
            CASE F2$                    ' average the data
                AVERAGE
            ' --------------------------
            CASE F3$                    ' polynomial fit
                POLYMAST
            ' --------------------------
            CASE F4$                    ' period search
                DCDFT
                STATCOMP
                SHOWRAW
            ' --------------------------
            CASE F5$                    ' time retreat
                TSPAN = TUPLIM - TLOLIM
                TLOLIM = INT(TLOLIM - TSPAN / 2 + .5)
                IF TLOLIM < 0 THEN TLOLIM = 0
                TUPLIM = TLOLIM + TSPAN
                STATCOMP
                SHOWRAW
            ' --------------------------
            CASE F6$                    ' time advance
                TSPAN = TUPLIM - TLOLIM
                TUPLIM = INT(TUPLIM + TSPAN / 2 + .5)
                IF TUPLIM > TUPLIMIT THEN TUPLIM = TUPLIMIT
                TLOLIM = TUPLIM - TSPAN
                STATCOMP
                SHOWRAW
            ' --------------------------
            CASE F7$                    ' zoom in/out
                ZOOMVIEW
            ' --------------------------
            CASE F8$
                KSEL$ = F6$
                POLYMAST
            ' --------------------------
            CASE "L"                    ' JD limits
                LIMITS NEGF
            ' --------------------------
            CASE F9$                    ' refresh screen
                CLS 2
                SHOWRAW
            ' --------------------------
            CASE F11$
                PROMPT "BIAS"
                LOCATE 22, 30
                GETNAME ZZ$, 0
                IF ZZ$ > "A" AND ZZ$ < "zz" THEN
                    ZZ$ = UCASE$(ZZ$)
                    SELECT CASE ZZ$
                        '---------------
                        CASE "ON"
                            IF NBIASAVE > 0 THEN NBIAS = NBIASAVE
                        '---------------
                        CASE "OFF"
                            NBIASAVE = NBIAS: NBIAS = 0
                        '---------------
                        CASE ELSE
                            IF LEN(ZZ$) < 4 THEN
                                ZZ$ = ZZ$ + SPACE$(4 - LEN(ZZ$))
                            END IF
                            FOR N = 1 TO NBIAS
                                IF ZZ$ = OBIAS(N) THEN
                                    FOR NA = N + 1 TO NBIAS
                                        OBIAS(NA - 1) = OBIAS(NA)
                                    NEXT NA
                                    NBIAS = NBIAS - 1
                                    GOTO BIASOFF
                                END IF
                            NEXT N
                            NBIAS = NBIAS + 1
                            OBIAS(NBIAS) = ZZ$
BIASOFF:
                        '---------------
                    END SELECT
                END IF
            ' --------------------------
            CASE "M", "m"               ' place a MARKER
                MARKER
            ' --------------------------
            CASE BACK$
                POINTID
                EDIT -1
                DO
                    MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                LOOP UNTIL RBUT% = 0
                GOTO NOPROMPT
            ' --------------------------
            CASE CR$
                POINTID
                EDIT 0
                GOTO NOPROMPT
            ' --------------------------
            CASE "P", "p"               ' save a POINT
                    IF NACTUAL < 0 THEN
                        PRINT #1, USING JDFORM$; DT0 + TVEC(NTHIS);
                        PRINT #1, USING FMT$; XVEC(NTHIS);
                        IF OBS(NTHIS) <> NOOBS$ THEN
                            PRINT #1, BL$; OBS(NTHIS);
                        END IF
                    ELSE
                        PRINT #1, USING JDFORM$; DT0 + TCUR;
                        PRINT #1, USING FMT$; MCUR;
                    END IF
                    IF TMARK > 0 THEN
                        PRINT #1, "  Relative offset ";
                        PRINT #1, USING JDFORM$; TCUR - TMARK;
                        PRINT #1, USING FMT$; MAGMARK - MCUR
                        LOCATE 21, 46
                        COLOR 15, 0
                        PRINT USING JDFORM$; DT0 + TCUR;
                        COLOR 7, 0
                    END IF
                    CLS 2
                    LOCATE 19, 1
                    PRINT "Comment? ";
                    GETNAME ZZ$, -78
                    ZZ$ = RTRIM$(ZZ$)
                    PRINT #1, BL$; ZZ$
            ' --------------------------
        END SELECT
        NLASTX = 0
        DO
            MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
        LOOP UNTIL LBUT% = 0
    LOOP
ALLDUN:
    SCREEN 0
    CLOSE
    IF NTEXT = -1 THEN
        SHELL "DEL " + FOVR$
    END IF
    SYSTEM
MISTAKEN:
    NEGF = -1
    RESUME NEXT
NOSUCH:
    PRINT "File "; FIN$; " not found."
    RESUME GETFIN
    END

    SUB AVERAGE
    ' ****************
    ' *  SUBROUTINE  *
    ' * average data *
    ' ****************
    IF TSIZE = 0 THEN TSIZE = 10
    CLS 2: PRINT "Size of time slot ="; TSIZE
    LOCATE CSRLIN - 1, 21: GETNAME ZZ$, 0
    TSIZE = VAL(ZZ$)
    IF TSIZE <= 0 THEN EXIT SUB
    PRINT "Error bars? Y";
    GETRESP ERB$
    NUMRED = 0
    TLOSAV = TLOLIM
    TUPSAV = TUPLIM
    DTEMP = DT0 + TLOLIM
    DTEMP = INT(DTEMP / TSIZE + .5)
    DTEMP = TSIZE * DTEMP - DT0
    T1 = DTEMP - TSIZE / 2
    T2 = T1 + TSIZE - .00001
    DO
        TLOLIM = T1
        IF TLOLIM < TLOSAV THEN TLOLIM = TLOSAV
        TUPLIM = T2
        IF TUPLIM > TUPSAV THEN TUPLIM = TUPSAV
        T1 = T1 + TSIZE: T2 = T2 + TSIZE
        STATCOMP
        IF NUMACT > 0 THEN
            NUMRED = NUMRED + 1
            NFIT(NUMRED) = NUMACT
            XFIT(NUMRED) = DAVE
            IF NUMACT > 1 THEN
                SFIT(NUMRED) = DSIG
            ELSE
                SFIT(NUMRED) = 0
            END IF
            TFIT(NUMRED) = DTAVE
            IF NUMRED > 1 THEN          ' plot the reduced data
                LINE -(TFIT(NUMRED), XFIT(NUMRED)), 12
            ELSE
                PSET (TFIT(NUMRED), XFIT(NUMRED))
            END IF
        END IF
    LOOP UNTIL T1 > TUPSAV OR T1 > TVEC(NUMRAW)
    TLOLIM = TLOSAV
    TUPLIM = TUPSAV
    STATCOMP
    IF ERB$ = YES$ THEN
        FOR N22 = -2 TO 2 STEP 4
            XLAST = TFIT(1): YLAST = XFIT(1) + N22 * SFIT(1)
            FOR N = 2 TO NUMRED
                X = TFIT(N): Y = XFIT(N) + N22 * SFIT(N)
                IF SFIT(N) > 0 AND SFIT(N - 1) > 0 THEN
                    LINE (XLAST, YLAST)-(X, Y), 13
                END IF
                XLAST = X: YLAST = Y
            NEXT N
        NEXT N22
        FOR N = 1 TO NUMRED
            IF NFIT(N) > 1 THEN
                Y0 = SFIT(N) / SQR(NFIT(N))
                Y1 = XFIT(N) - 2 * Y0: Y2 = XFIT(N) + 2 * Y0
                LINE (TFIT(N), Y1)-(TFIT(N), Y2), 14
            END IF
        NEXT N
    END IF
    PRINT : PRINT "Save these results to a file? N";
    GETRESP ZZ$
    IF ZZ$ = YES$ THEN
        FAVE$ = ROOT$ + ".AVE"
        PRINT "File = "; FAVE$
        LOCATE CSRLIN - 1, 8: GETNAME FAVE$, 0
        IF LEN(FAVE$) > 0 THEN
            PRINT
            OPEN "A", 4, FAVE$
            FOR N = 1 TO NUMRED
                PRINT #4, USING JDFORM$; DT0 + TFIT(N);
                PRINT #4, USING FMT$; XFIT(N); SFIT(N);
                PRINT #4, USING " ####"; NFIT(N)
            NEXT N
            CLOSE 4
        END IF
    END IF
    END SUB

    SUB BREAKOUT
    ' **************
    ' * SUBROUTINE *
    ' **************
    NBRAKE = 0
    K$ = INKEY$
    IF K$ = ESC$ OR K$ = "Q" OR K$ = "q" THEN
        LOCATE 20, 1: PRINT "End? N";
        GETRESP YN$
        IF YN$ = YES$ THEN NBRAKE = -1
        IF YN$ = "S" THEN CLS 1
    END IF
    END SUB

    SUB DCDFT
    ' *********************
    ' *    SUBROUTINE     *
    ' * Fourier Transform *
    ' *********************
    ' Date-Compensated Discrete Fourier Transform
    DIM DTEST(NBEST)                    ' frequ/per to scan
    DIM DRES(NBEST)                     ' resolution of scan
    NPOLY = 0
    DPOLYAMP2 = 0                       ' polynomial AMP^2
    DFOURAMP2 = 0                       ' FOURIER AMP^2
    STATCOMP
    ' =============================
    ' = compute Fourier transform =
    ' =============================
    MSG$ = "       DCDFT "
    ' ============================================
    ' = compute half estimated Nyquist frequency =
    ' ============================================
    DANG0 = 1 / SQR(12 * DTVAR) / 4
    DANG00 = DANG0: MAGRES = 1
    DANGCUT = .95 * DANG0
    DAMPLIT = INT((MB - MA) / 2) + 1
    DT = (TVEC(NUPLIM) - TVEC(NLOLIM)) / NUMACT
    IF DT <= 0 THEN DT = 1
    TEMP2$ = "     Frequency     Period      Power  Amplitude"
    TEMP3$ = "      cos        sin       const"
    DO: KNAME$ = INKEY$: LOOP UNTIL KNAME$ = NUL$
    DO
        MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
    LOOP UNTIL LBUT% = 0 AND RBUT% = 0
REQUEST:
    DO
        XLO = 0: XHI = NUMACT * DT: YLO = 0: YHI = NUMACT / 2
        ' IF YHI > 500 THEN YHI = 500
        PROMPT "DFT "                   ' display prompts
        MOUSESHOW                       ' show the mouse
        DO
            MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
        LOOP UNTIL KSEL$ <> NUL$
        MOUSEHIDE
        DLAMP = 0
        SELECT CASE KSEL$
            '---------------------------
            CASE F1$                    ' standard SCAN
            NFRE = 1
            HIFRE = NUMACT * DANG0
            ' IF HIFRE > .05 THEN HIFRE = .05
            SETGRAPH XLO, HIFRE, YLO, YHI, 0
            PRINT #1, MSG$;
            LOGNOW
            PRINT #1, TEMP2$
            PROMPT "DFT9"
            VIEW PRINT 20 TO 24
            FOR NJ = 1 + NPOLY TO NUMACT' *do for each test frequency
                FF = NJ * DANG0         '   compute test frequ
                ' IF FF > .05 THEN GOTO LBLS
                FFT FF
                IF NBRAKE < 0 THEN
                    STATCOMP
                    GOTO LBLS
                END IF
            NEXT NJ                     ' *enddo
LBLS:
            VIEW PRINT 19 TO 25
            KSEL$ = NUL$
            '---------------------------
            CASE F2$                    ' FREQUENCY range
                NFRE = 1
FREQRANGE:                              ' entry point for SLICK
                NDIM = NPOLY + 2 * NFRE
                PRINT
                PRINT " Low Fre = "; XLOFRE;
                LOCATE CSRLIN, 12: GETNAME ZZ$, 0
                XLOFRE = VAL(ZZ$)
                IF XLOFRE = 0 THEN XLOFRE = (NDIM + 1) * DANG0 / 2
                PRINT "High Fre = "; HIFRE;
                LOCATE CSRLIN, 12: GETNAME ZZ$, 0
                HIFRE = VAL(ZZ$)
                IF HIFRE = 0 THEN
                    HIFRE = XLOFRE
                    RES = DANG0
                ELSE
                    PRINT "Res = "; RES;
                    LOCATE CSRLIN, 7: GETNAME ZZ$, 0
                    RES = VAL(ZZ$)
                    IF RES = 0 THEN RES = DANG0
                END IF
                HIPER = 0
                IF XLOFRE <> 0 THEN HIPER = 1 / XLOFRE
                XLOPER = 0
                IF HIFRE <> 0 THEN XLOPER = 1 / HIFRE
                PRINT "AOK? Y";
                GETRESP YN$
                IF YN$ <> YES$ THEN GOTO LBLF
                IF HIFRE > XLOFRE THEN
                    SETGRAPH XLOFRE, HIFRE, YLO, YHI, 0
                    PRINT #1, MSG$;
                    LOGNOW
                    PRINT #1, TEMP2$
                    PROMPT "DFT9"
                    VIEW PRINT 20 TO 24
                    FOR FF = XLOFRE TO HIFRE STEP RES
                        FFT FF
                        IF NBRAKE < 0 THEN
                            STATCOMP
                            GOTO LBLF
                        END IF
                    NEXT FF
                ELSE
                    FF = 1 / XLOPER
                    FFT FF
                    DGPOWER(NBEST) = 0: TABLIT
                END IF
LBLF:
                DFOURAMP2 = DPOLYAMP2   ' cancel FOURIER amp^2
                VIEW PRINT 19 TO 25
                KSEL$ = NUL$
            '---------------------------
            CASE F3$                    ' PERIOD range
                NFRE = 1
                PRINT
                PRINT " Low Per = "; XLOPER;
                LOCATE CSRLIN, 12: GETNAME ZZ$, 0
                XLOPER = VAL(ZZ$)
                PRINT "High Per = "; HIPER;
                LOCATE CSRLIN, 12: GETNAME ZZ$, 0
                HIPER = VAL(ZZ$)
                IF HIPER <= 0 THEN
                    HIPER = LOPER
                    RES = 1
                ELSE
                    PRINT "Res = "; RES;
                    LOCATE CSRLIN, 7: GETNAME ZZ$, 0
                    RES = VAL(ZZ$)
                END IF
                HIFRE = 0
                IF XLOPER <> 0 THEN HIFRE = 1 / XLOPER
                XLOFRE = 0
                IF HIPER <> 0 THEN XLOFRE = 1 / HIPER
                PRINT "AOK? Y";
                GETRESP YN$
                IF YN$ <> YES$ THEN GOTO LBLJ
                PRINT #1, MSG$;
                LOGNOW
                PRINT #1, TEMP2$
                PROMPT "DFT9"
                VIEW PRINT 20 TO 24
                IF HIPER >= XLOPER + RES THEN
                    SETGRAPH XLOFRE, HIFRE, YLO, YHI, 0
                    FOR PPER = HIPER TO XLOPER STEP -RES
                        FF = 0
                        IF PPER <> 0 THEN FF = 1 / PPER
                        FFT FF
                        IF NBRAKE < 0 THEN
                            STATCOMP
                            GOTO LBLJ
                        END IF
                    NEXT PPER
                ELSE
                    FF = 1 / XLOPER
                    FFT FF
                    DGPOWER(NBEST) = 0: TABLIT
                END IF
LBLJ:
                VIEW PRINT 19 TO 25
                KSEL$ = NUL$
            '---------------------------
            CASE F4$
                PROMPT "DFTP"           ' ask user for poly degree
                LOCATE 20, 9: PRINT NPOLY;
                LOCATE 20, 10
                GETNAME ZZ$, 0
                NPOLY = VAL(ZZ$)
                IF NPOLY < 0 THEN NPOLY = 0
                ' =====================================
                ' = compute AMP^2 of polynomial alone =
                ' =====================================
                NFRE = 0
                PROJECT
                DPOLYAMP2 = DAMP2                   ' polynomial AMP^2
                DFOURAMP2 = DAMP2                   ' FOURIER AMP^2
            '---------------------------
            CASE F5$                    ' delete from TABLE
                DO
                    SHOWBEST
                    PRINT "Delete #";
                    GETNAME ZZ$, 0
                    NCHANGE = 0
                    IF RIGHT$(ZZ$, 1) = "+" THEN
                        ZZ$ = LEFT$(ZZ$, LEN(ZZ$) - 1)
                        NCHANGE = -1
                    END IF
                    N = VAL(ZZ$)
                    IF N > 0 AND N < 21 THEN
                        FOR NA = N TO NBEST - 1
                            IF NCHANGE < 0 THEN
                                DGNU(NA) = 0
                                DGPOWER(NA) = 0
                            ELSE
                                DGNU(NA) = DGNU(NA + 1)
                                DGPOWER(NA) = DGPOWER(NA + 1)
                                DGPER(NA) = DGPER(NA + 1)
                            END IF
                        NEXT NA
                        DGNU(NBEST) = 0: DGPOWER(NBEST) = 0
                        DGPER(NBEST) = 0
                    END IF
                LOOP UNTIL ZZ$ = NUL$ OR ZZ$ = ESC$
                KSEL$ = NUL$
            '---------------------------
            CASE F6$                    ' MODEL the data
                GETFREQ
                PRINT "Save residuals? N";
                GETRESP RFIL$
                IF RFIL$ = YES$ THEN
                    FRES$ = FIN$
                    NX = INSTR(FRES$, DOT$)
                    IF NX = 0 THEN NX = LEN(FRES$) + 1
                    FRES$ = LEFT$(FRES$, NX - 1) + ".RES"
                    PRINT "File = "; FRES$
                    LOCATE CSRLIN - 1, 8: GETNAME FRES$, 0
                    OPEN "O", 9, FRES$
                END IF
                AVEMOD = 0: VARMOD = 0
                YHI = DAMPLIT: YLO = -YHI
                XLO = TVEC(NLOLIM)
                XHI = TVEC(NUPLIM)
                SETGRAPH XLO, XHI, YLO, YHI, 0
                LINE (XLO, 0)-(XHI, 0)
                CLS 2
                ' ========================
                ' = compute coefficients =
                ' ========================
                PRINT "Computing..."
                PROJECT
                ' ===================================
                ' = report coefficients to log file =
                ' ===================================
                PRINT #1, SPACE$(7); "POW=";
                PRINT #1, USING FMT$; DFPOW;
                PRINT #1, BL$;
                LOGNOW
                FOR NP = 1 TO NPOLY
                    PRINT #1, "Poly"; NP;
                    PRINT #1, USING FMT$; DCOEF(NP); DTSCALE
                NEXT NP
                NB = NPOLY + 2 * NFRE
                FOR NN = 1 TO NBIAS
                    PRINT #1, OBIAS(NN);
                    PRINT #1, USING FMT$; DCOEF(NB + NN)
                NEXT NN
                PRINT #1, TEMP2$; TEMP3$
                NB = NPOLY
                FOR NN = 1 TO NFRE
                    NB = NB + 2: NA = NB - 1
                    PRINT #1, USING FREQFORM$; DFRE(NN);
                    PRINT #1, USING JDFORM$; 1 / DFRE(NN);
                    PRINT #1, "     Fre";
                    IF NN < 10 THEN
                        PRINT #1, "0";
                        PRINT #1, USING "#"; NN;
                    ELSE
                        PRINT #1, USING "##"; NN;
                    END IF
                    DD = DCOEF(NA) ^ 2 + DCOEF(NB) ^ 2
                    PRINT #1, USING FMT$; SQR(DD); DCOEF(NA);
                    PRINT #1, USING FMT$; DCOEF(NB); DCOEF(0)
                NEXT NN
                ' LOCATE 19, 1
                ' COLOR 15, 0: PRINT "DATA";
                ' COLOR 14, 0: PRINT "  MODEL";
                ' COLOR 12, 0: PRINT "  RESID";
                ' COLOR 7, 0
                TTL = 0: XML = 0: RESIDL = 0
                ' ===========================
                ' = compute and plot points =
                ' ===========================
                FOR N = NLOLIM TO NUPLIM
                    BREAKOUT
                    IF NBRAKE < 0 THEN GOTO NOMODEL
                    IF WVEC(N) > 0 THEN
                        TT = TVEC(N)
                        DT = TT
                        SMOOTH DT, DX
                        XM = DX
                        RESID = XVEC(N) - XM
                        FOR NB = 1 TO NBIAS
                            IF OBS(N) = OBIAS(NB) THEN
                                RESID = RESID - DCOEF(NDIM2 + NB)
                            END IF
                        NEXT NB
                        IF RFIL$ = YES$ THEN
                            PRINT #9, USING JDFORM$; TT + DT0;
                            PRINT #9, USING FMT$; RESID;
                            IF OBS(N) <> NOOBS$ THEN
                                PRINT #9, BL$; OBS(N);
                            END IF
                            PRINT #9, USING FMT$; XVEC(N); XM
                        END IF
                        LINE (TTL, XML - DAVE)-(TT, XM - DAVE), 14
                                        '  residual red
                        LINE (TTL, RESIDL)-(TT, RESID), 12
                                        ' plot data white
                        PSET (TT, XVEC(N) - DAVE), 15
                        TTL = TT: XML = XM: RESIDL = RESID
                        AVEMOD = AVEMOD + RESID
                        VARMOD = VARMOD + RESID ^ 2
                    END IF
                NEXT N
                CLOSE 9
                AVEMOD = AVEMOD / NUMACT
                VARMOD = VARMOD / (NUMACT - 1)
                RDEV = SQR(VARMOD - AVEMOD ^ 2)
                PRINT " ave "; AVEMOD;
                PRINT " sdev "; RDEV;
NOMODEL:
                KSEL$ = NUL$
            '---------------------------
            CASE F7$                    ' SLICK spectrum
            GETFREQ
            PROJECT
            DFOURAMP2 = DAMP2           ' FOURIER AMP^2
            NFRE = NFRE + 1
            GOTO FREQRANGE
            '---------------------------
            CASE F8$                    ' multi-period scan
                GETFREQ
                FOR N = 1 TO NFRE
                    DTEST(N) = 1 / DFRE(N)
                    DRES(N) = (DANG0 * DTEST(N) ^ 2) / 10
                    RESOLVE DRES(N), DTEST(N)
                NEXT N
                CLS 2
                ' ===========================
                ' = select variable periods =
                ' ===========================
                DO
                    PRINT "Variable Per ";
                    GETNAME ZZ$, 0
                    DFF = VAL(ZZ$)
                    IF DFF > 0 THEN
                        NFRE = NFRE + 1
                        DTEST(NFRE) = DFF
                        DRES(NFRE) = (DANG0 * DTEST(NFRE) ^ 2) / 10
                        LOCATE CSRLIN - 1, 26
                        PRINT "Res ";
                        PRINT USING FMT$; DRES(NFRE)
                        LOCATE CSRLIN - 1, 30
                        GETNAME ZZ$, 0
                        DRES(NFRE) = VAL(ZZ$)
                    END IF
                LOOP UNTIL DFF <= 0
                NVARY = NFRE            ' number VARIABLE frequ/per
                ' ======================
                ' = get locked periods =
                ' ======================
                DO
                    PRINT "Locked Per ";
                    GETNAME ZZ$, 0
                    DFF = VAL(ZZ$)
                    IF DFF > 0 THEN
                        NFRE = NFRE + 1
                        DTEST(NFRE) = DFF
                        DRES(NFRE) = 0
                    END IF
                LOOP UNTIL DFF <= 0
                PRINT "AOK? Y";
                GETRESP AOK$
                DBPOWER = 0
                IF AOK$ <> YES$ THEN GOTO LBLF7OUT2
                ' ======================
                ' = perform multi-scan =
                ' ======================
                PRINT #1, "MULTI: ";
                LOGNOW
                ' =====================
                ' =====================
                ' = multi-PERIOD scan =
                ' =====================
                ' =====================
                    ' ======================
                    ' = compute BASE level =
                    ' ======================
                    FOR N = 1 TO NFRE
                        DFRE(N) = 1 / DTEST(N)
                    NEXT N
                    PROJECT
                    DBPOWER = DFPOW     ' set base level for power
                    IF DBPOWER = 0 THEN DBPOWER = 1
                    NSOFAR = 0
                    NV = 0
                    NVLAST = 0          ' last changed frequ
                    NCHANGE = 0
                    ' ======================
                    ' = refine the periods =
                    ' ======================
                    DO
                        IF NCHANGE < 0 AND NVLAST > 0 THEN
                            SWAP NV, NVLAST
                        ELSE
                            IF NCHANGE < 0 THEN NVLAST = NV
                            NV = NV + 1
                            IF NV > NVARY THEN NV = 1
                        END IF
                        IF NBRAKE < 0 THEN
                            STATCOMP
                            GOTO LBLF7OUT
                        END IF
                        NCHANGE = 0     ' init to NO CHANGE
                        ' =======================
                        ' = test higher periods =
                        ' =======================
                        DO
                            DTEST(0) = DTEST(NV) + DRES(NV)
                            DFRE(NV) = 1 / DTEST(0)
                            PRINT USING FMT$; DTEST(0);
                            PRINT USING FREQFORM$; DFRE(NV);
                            PROJECT
                            PRINT USING FMT$; DFPOW
                            IF DFPOW > DBPOWER THEN  ' *if better then
                                DBPOWER = DFPOW      '   save new ampl.
                                DTEST(NV) = DTEST(0) '  save new per.
                                NCHANGE = -1         ' mark CHANGED
                                NSOFAR = -1          ' mark CHANGED
                            ELSE
                                DFPOW = 0
                            END IF                  ' *endif
                            ' =====================
                            ' = allow user ESCape =
                            ' =====================
                            IF NBRAKE < 0 THEN GOTO BRAKEMANY
                        LOOP UNTIL DFPOW < DBPOWER
                        IF NCHANGE = 0 THEN
                            ' ======================
                            ' = test lower periods =
                            ' ======================
                            DO
                                DTEST(0) = DTEST(NV) - DRES(NV)
                                DFRE(NV) = 1 / DTEST(0)
                                PRINT USING FMT$; DTEST(0);
                                PRINT USING FREQFORM$; DFRE(NV);
                                PROJECT
                                PRINT USING FMT$; DFPOW
                                IF DFPOW > DBPOWER THEN  ' *if better
                                    DBPOWER = DFPOW      '   save ampl.
                                    DTEST(NV) = DTEST(0) '  save per.
                                    NSOFAR = -1         ' mark CHANGED
                                    NCHANGE = -1         ' mark CHANGED
                                ELSE
                                    DFPOW = 0
                                END IF                  ' *endif
                                ' =====================
                                ' = allow user ESCape =
                                ' =====================
                                IF NBRAKE < 0 THEN GOTO BRAKEMANY
                            LOOP UNTIL DFPOW < DBPOWER
                        END IF
BRAKEMANY:
                        DFRE(NV) = 1 / DTEST(NV)
                        FOR N = 1 TO NFRE
                            PRINT #1, USING FMT$; DTEST(N);
                        NEXT N
                        PRINT #1, USING FMT$; DBPOWER
                        PRINT USING FMT$; DBPOWER;
                        NSOFAR = NSOFAR + 1
                        PRINT NSOFAR
                    LOOP UNTIL NSOFAR >= NVARY
                ' ==========================
                ' = save best set to table =
                ' ==========================
LBLF7OUT:
                DLPOWER = DBPOWER
                FOR N = 1 TO NFRE
                    DLPER = DTEST(N): DLNU = 1 / DLPER
                    TABLIT
                NEXT N
LBLF7OUT2:
                ' BEEP: BEEP
                KSEL$ = NUL$
            '---------------------------
            'CASE F9$                    ' set OVERTONE level
            '---------------------------
            CASE F10$
                PRINT : PRINT "Res.magn.="; MAGRES;
                LOCATE CSRLIN, 12
                GETNAME ZZ$, 0
                MM = VAL(ZZ$)
                IF MM >= .01 AND MM <= 100 THEN
                    MAGRES = MM
                    DANG0 = DANG00 / MAGRES
                END IF
            '---------------------------
            CASE ESC$                   ' exit
                LOCATE 19, 1: PRINT "Exit FFT? Y";
                GETRESP ZZ$
                IF ZZ$ = YES$ THEN KSEL$ = ESC$
            '---------------------------
            ' CASE ELSE
                ' BEEP
            '---------------------------
        END SELECT
    LOOP UNTIL KSEL$ = ESC$
    CLOSE 2: CLOSE 3                    ' close output, plot files
    END SUB

    SUB EDIT (NTYPE)
    ' **************
    ' * SUBROUTINE *
    ' * edit point *
    ' **************
    ' LOCATE 22, 40: PRINT SPACE$(39);
    IF NACTUAL < 0 THEN
        NT = NTHIS - 1
        DO
            NT = NT + 1
            IF NT > NUMRAW THEN GOTO ALLPOINT
            NXX = PMAP(TVEC(NT), 0)
            IF NXX > XMOUSE THEN GOTO ALLPOINT
            NYY = PMAP(XVEC(NT), 1)
            IF NYY = YMOUSE THEN
                IF NTYPE < 0 THEN
                    WVEC(NT) = -WVEC(NT)
                    IF WVEC(NT) <= 0 THEN
                        PSET (TCUR, MCUR), BAD
                    ELSE
                        PSET (TCUR, MCUR), GOOD
                    END IF
                END IF
            END IF
        LOOP
ALLPOINT:
    END IF
    END SUB

    SUB FFT (FF)
    ' **************
    ' * SUBROUTINE *    FF = the frequence to be tested
    ' *fast Fourier*
    ' **************
    IF FF <> 0 THEN PP = 1 / FF         ' compute actual period
    PRINT USING FREQFORM$; FF;
    PRINT USING FMT$; PP;
    PRINT #1, USING FREQFORM$; FF;
    PRINT #1, USING FMT$; PP;
    DFRE(NFRE) = FF
    PROJECT                             ' compute Fourier transform
    IF NBRAKE < 0 THEN EXIT SUB
    ' =================================
    ' = date compensation is complete =
    ' =================================
    LINE -(FF, DFPOW), 12
    PSET (DLNU, DLPOWER), 14
    PSET (FF, DFPOW), 14
    PRINT USING FMT$; DFPOW; DAMP
    ' *****************************
    ' * MATT: here's the old code *
    ' *****************************
    ' PRINT #1, USING FMT$; DFPOW; DAMP * SQR(2)
    ' ***************************
    ' * and here's the new code *
    ' ***************************
                    NA = NPOLY + 1: NB = NA + 1
                    DD = SQR(DCOEF(NA) ^ 2 + DCOEF(NB) ^ 2)
                    PRINT #1, USING FMT$; DFPOW; DD
    ' ***********************
    ' * end of the new code *
    ' ***********************
    IF DAMP < DLAMP AND DLAMP >= DLLAMP THEN
        LOCATE CSRLIN - 2, 34: PRINT "**"
        LOCATE CSRLIN + 1, 1
        TABLIT
    END IF
    DLLAMP = DLAMP: DLAMP = DAMP
    DLNU = FF: DLPER = PP
    DLPOWER = DFPOW
    END SUB

    SUB GETFREQ
    ' **************
    ' * SUBROUTINE *
    ' *  get name  *
    ' **************
    SHOWBEST
    PRINT
    NFRE = 0
    ZZ$ = NUL$
    FOR NR = 1 TO NBEST
        IF DGPOWER(NR) = 0 THEN GOTO NOMOREFR
        IF ZZ$ <> "A" THEN
            LOCATE CSRLIN - 1, 1: PRINT SPACE$(79);
            LOCATE CSRLIN, 1: PRINT "Include frequ ";
            PRINT USING "#"; NR;
            PRINT "? N";
            GETRESP ZZ$
        END IF
        IF ZZ$ = ESC$ THEN GOTO NOMOREFR
        IF ZZ$ = YES$ OR ZZ$ = "A" THEN
            NFRE = NFRE + 1
            DFRE(NFRE) = DGNU(NR)
        END IF
    NEXT NR
NOMOREFR:                               ' no more table frequencies
    END SUB

    SUB GETNAME (ZZ$, NGETFLAG)
    ' **************
    ' * SUBROUTINE *
    ' *  get name  *
    ' **************
    ' Input is from user.  Output is the string ZZ$
    DO: KNAME$ = INKEY$: LOOP UNTIL KNAME$ = NUL$
    DO
        MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
    LOOP UNTIL LBUT% = 0 AND RBUT% = 0
    NLIN = CSRLIN: NCOLST = POS(0)
    LOCATE NLIN, NCOLST, 1, 7
    NHOLFLAG = 0
    IF NGETFLAG < 0 THEN
        NHOLFLAG = -1
        NLIMIT = -NGETFLAG
    END IF
    IF NGETFLAG > 0 THEN NGETFLAG = 0
    NINFLAG = 0                         ' init insert flag OFF
GETCHAR:
    DO
        DUMMY$ = CHR$(SCREEN(NLIN, POS(0)))
        IF NINFLAG < 0 THEN
            COLOR 13, 0
        ELSE
            COLOR 14, 0
        END IF
        IF DUMMY$ = BL$ THEN
            PRINT BARRY$;
        ELSE
            PRINT DUMMY$;
        END IF
        COLOR 7, 0
        LOCATE NLIN, POS(0) - 1
        DO
            IF MFLAG% THEN
                MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                KNAME$ = KSEL$
            ELSE
                KNAME$ = INKEY$
            END IF
        LOOP WHILE KNAME$ = NUL$ AND LBUT% = 0 AND RBUT% = 0
        IF LBUT% < 0 OR RBUT% < 0 THEN
            KNAME$ = NUL$
            IF LBUT% < 0 THEN KNAME$ = CR$
            IF RBUT% < 0 THEN
                IF DUMMY$ = YES$ THEN
                    DUMMY$ = NO$
                ELSE
                    IF DUMMY$ = NO$ THEN
                        DUMMY$ = YES$
                    END IF
                END IF
            END IF
            DO
                MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
            LOOP UNTIL LBUT% = 0 AND RBUT% = 0
        END IF
        PRINT DUMMY$;
        LOCATE NLIN, POS(0) - 1
        SELECT CASE KNAME$
            '---------------------------
            CASE BL$ TO "z"
                IF NGETFLAG = 0 THEN
                    PRINT SPACE$(80 - NCOLST);
                    LOCATE NLIN, NCOLST, 1, 7
                END IF
                IF NINFLAG = 0 THEN
                    PRINT KNAME$;
                ELSE
                    NCOL = POS(0)
                    NNAME = NCOL
                    CCC$ = KNAME$
                    IF NHOLFLAG < 0 THEN
                        DO
                            CCCC$ = CHR$(SCREEN(NLIN, NNAME))
                            PRINT CCC$;
                            CCC$ = CCCC$
                            NNAME = NNAME + 1
                        LOOP UNTIL NNAME > NLIMIT
                    ELSE
                        DO
                            CCCC$ = CHR$(SCREEN(NLIN, NNAME))
                            PRINT CCC$;
                            CCC$ = CCCC$
                            NNAME = NNAME + 1
                        LOOP UNTIL CCC$ = BL$
                    END IF
                    LOCATE NLIN, NCOL + 1, 1, 0, 7
                END IF
            '---------------------------
            CASE LARR$
                NCOL = POS(0) - 1
                IF NCOL < NCOLST THEN NCOL = NCOLST
                LOCATE NLIN, NCOL, 1, 7
            '---------------------------
            CASE RARR$
                NCOL = POS(0) + 1
                IF NCOL > 80 THEN NCOL = 80
                LOCATE NLIN, NCOL, 1, 7
            '---------------------------
            CASE DELT$, BACK$
                NNAME = POS(0)
                IF KNAME$ = BACK$ THEN
                    NNAME = NNAME - 1
                    LOCATE NLIN, NNAME
                END IF
                NCOL = NNAME
                IF NHOLFLAG < 0 THEN
                    DO UNTIL NNAME > NLIMIT
                        Z$ = CHR$(SCREEN(NLIN, NNAME + 1))
                        PRINT Z$;
                        NNAME = NNAME + 1
                    LOOP
                ELSE
                    DO UNTIL SCREEN(NLIN, NNAME) = 32
                        Z$ = CHR$(SCREEN(NLIN, NNAME + 1))
                        PRINT Z$;
                        NNAME = NNAME + 1
                    LOOP
                END IF
                LOCATE NLIN, NCOL, 1, 7
            '---------------------------
            CASE HOME$
                LOCATE NLIN, NCOLST, 1, 7
            '---------------------------
            CASE EEND$
                NNAME = NCOLST
                IF NHOLFLAG < 0 THEN
                    LOCATE NLIN, NLIMIT, 1, 7
                ELSE
                    DO UNTIL SCREEN(NLIN, NNAME) = 32 OR NNAME = 80
                        NNAME = NNAME + 1
                    LOOP
                    LOCATE NLIN, NNAME, 1, 7
                END IF
            '---------------------------
            CASE CR$
            '---------------------------
            CASE INSR$
                NINFLAG = -(NINFLAG + 1)
                IF NINFLAG = 0 THEN
                    LOCATE CSRLIN, POS(0), 1, 7
                ELSE
                    LOCATE CSRLIN, POS(0), 1, 0, 7
                END IF
            '---------------------------
            CASE CTLA$
                IF NHOLFLAG < 0 THEN
                    NNAME = POS(0)
                    IF NNAME > 2 THEN
                        DO
                            NNAME = NNAME - 1
                            Z$ = CHR$(SCREEN(NLIN, NNAME))
                        LOOP UNTIL Z$ = BL$ OR NNAME = 2
                        DO
                            NNAME = NNAME - 1
                            Z$ = CHR$(SCREEN(NLIN, NNAME))
                        LOOP UNTIL Z$ <> BL$ OR NNAME = 1
                        LOCATE NLIN, NNAME, 1, 7
                    END IF
                ' ELSE
                    ' BEEP
                END IF
            '---------------------------
            CASE CTRA$
                IF NHOLFLAG < 0 THEN
                    NNAME = POS(0) - 1
                    DO
                        NNAME = NNAME + 1
                        Z$ = CHR$(SCREEN(NLIN, NNAME))
                    LOOP UNTIL Z$ = BL$ OR NNAME >= NLIMIT - 1
                    DO
                        NNAME = NNAME + 1
                        Z$ = CHR$(SCREEN(NLIN, NNAME))
                    LOOP UNTIL Z$ <> BL$ OR NNAME >= NLIMIT
                    LOCATE NLIN, NNAME, 1, 7
                ' ELSE
                    ' BEEP
                END IF
            '---------------------------
            CASE ESC$
                ZZ$ = ESC$
                EXIT SUB
            '---------------------------
        END SELECT
        NGETFLAG = 1
    LOOP UNTIL KNAME$ = CR$
    ZZ$ = NUL$
    NNAME = NCOLST
    IF NHOLFLAG < 0 THEN
        DO UNTIL NNAME > NLIMIT
            Z$ = CHR$(SCREEN(NLIN, NNAME))
            ZZ$ = ZZ$ + Z$
            NNAME = NNAME + 1
        LOOP
    ELSE
        DO UNTIL SCREEN(NLIN, NNAME) <> 32 OR NNAME > 79
            NNAME = NNAME + 1
        LOOP
        DO UNTIL SCREEN(NLIN, NNAME) = 32 OR NNAME > 80
            Z$ = CHR$(SCREEN(NLIN, NNAME))
            ZZ$ = ZZ$ + Z$
            NNAME = NNAME + 1
        LOOP
    END IF
    LOCATE CSRLIN, POS(0), 1, 7
    PRINT
    END SUB

    SUB GETRESP (ZZ$)
    ' ****************
    ' *  SUBROUTINE  *
    ' * get response *
    ' ****************
    ' Input is from user.  Output is the string ZZ$
    LOCATE CSRLIN, POS(0) - 1
    GETNAME ZZ$, 0
    ZZ$ = UCASE$(LEFT$(ZZ$, 1))
    END SUB

    SUB KOPYRITE
    ' **************
    ' * SUBROUTINE *
    ' **************
    ' ==================
    ' = load constants =
    ' ==================
    CR$ = CHR$(13): ESC$ = CHR$(27)
    FF$ = CHR$(12): BARRY$ = CHR$(254)
    LARR$ = CHR$(0) + CHR$(75)          ' left arrow
    RARR$ = CHR$(0) + CHR$(77)          ' right arrow
    UARR$ = CHR$(0) + CHR$(72)          ' up arrow
    DARR$ = CHR$(0) + CHR$(80)          ' down arrow
    UPAG$ = CHR$(0) + CHR$(73)          ' page up
    DPAG$ = CHR$(0) + CHR$(81)          ' page down
    HOME$ = CHR$(0) + CHR$(71)          ' home
    DELT$ = CHR$(0) + CHR$(83)          ' del
    EEND$ = CHR$(0) + CHR$(79)          ' end
    BACK$ = CHR$(8)                     ' backspace
    TAAB$ = CHR$(9)                     ' tab key
    INSR$ = CHR$(0) + CHR$(82)          ' insert key
    CTLA$ = CHR$(0) + CHR$(115)         ' ctrl-left arrow
    CTRA$ = CHR$(0) + CHR$(116)         ' ctrl-right arrow
    F1$ = CHR$(0) + CHR$(59): F2$ = CHR$(0) + CHR$(60)
    F3$ = CHR$(0) + CHR$(61): F4$ = CHR$(0) + CHR$(62)
    F5$ = CHR$(0) + CHR$(63): F6$ = CHR$(0) + CHR$(64)
    F7$ = CHR$(0) + CHR$(65): F8$ = CHR$(0) + CHR$(66)
    F9$ = CHR$(0) + CHR$(67): F10$ = CHR$(0) + CHR$(68)
    F11$ = CHR$(0) + CHR$(133)
    NBINS = 20
    MA = 99: MB = -99                   ' init magnitude limits
    JDA$ = "0000000": JDB$ = "2460000"
    FOR N = 0 TO 53: READ NYELLOW(N): NEXT N
    NTCOL = 1: NXCOL = 2                ' columns for time, magnitude
    ' NOCOL = 3
    ' =============================
    ' = issue copyright statement =
    ' =============================
    CLS
    COLOR 14, 11
    LOCATE 5, 35: PRINT "TS v1 r2";
    LOCATE 7, 25: PRINT "Time Series Analysis Program";
    LOCATE 9, 15: PRINT "(c) Copyright 1997 AAVSO; all rights reserved."
    T0 = TIMER
    DO
        TT = TIMER - T0
    LOOP UNTIL TT > 3
    COLOR 7, 0
    SCREEN 9                            ' set to enhanced resolution
    VIEW PRINT 19 TO 25                 ' viewport for text
    ' =====================
    ' = install the mouse =
    ' =====================
    MFLAG% = 0
    MOUSE MFLAG%, 0, 0, 0
    IF MFLAG% THEN
            xHot% = 7
            yHot% = 7
            curs$ = NUL$
            FOR NN = 1 TO 66
                READ NNN
                curs$ = curs$ + CHR$(NNN)
            NEXT NN
            ' ====================
            ' = set mouse cursor =
            ' ====================
            xHot% = ASC(LEFT$(curs$, 1))
            yHot% = ASC(MID$(curs$, 2, 1))
            MOUSE 9, xHot%, yHot%, SADD(curs$) + 2
            MOUSE 1, 0, 0, 0
            MOUSE 2, 0, 0, 0
            MOUSE 15, 0, 15, 24         ' set mouse speed
    ELSE
        XMOUSE = 320: YMOUSE = 160
    END IF
    END SUB

    SUB LIMITS (NTYPE)
    ' **************
    ' * SUBROUTINE *
    ' **************
    TR2 = TRESOLV / 10
    FMT2$ = "##.#"
    SELECT CASE NTYPE
        ' ==============================
        CASE 1                          ' time lower limit entire
            PROMPT "DLOW"
            FMT2$ = "#######"
            NN = 3 - INT(LOG(TUPLIMIT) * TENLOG)
            IF NN > 0 THEN
                FMT2$ = FMT2$ + "." + STRING$(NN, 35)
            END IF
            WINDOW
            MOUSESHOW
            DO
                MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                IF XMOUSE <> XLAST THEN
                    XLAST = XMOUSE
                    IF XMOUSE < NRIGHT - 1 THEN
                        MOUSEHIDE
                        ' ============================
                        ' = show JD range bar at top =
                        ' ============================
                        LINE (NX0, 35)-(NX1, NY0), NOFF, BF
                        LINE (XMOUSE, 35)-(NRIGHT, NY0), NON, BF
                        LOCATE 19, 6
                        TLOLIM = TUPLIMIT * (XMOUSE - NX0) / NWIDE
                        X = TLOLIM / TR2 + .5
                        TLOLIM = TR2 * INT(X)
                        PRINT USING FMT2$; DT0 + TLOLIM
                        MOUSESHOW
                    END IF
                END IF
                IF MFLAG% = 0 THEN LBUT% = -1 - LBUT%
            LOOP UNTIL LBUT% = 0
            MOUSEHIDE
            IF TLOLIM < 0 THEN TLOLIM = 0
        ' ==============================
        CASE 2                          ' time upper limit entire
            PROMPT "DUP "
            FMT2$ = "#######"
            NN = 3 - INT(LOG(TUPLIMIT) * TENLOG)
            IF NN > 0 THEN
                FMT2$ = FMT2$ + "." + STRING$(NN, 35)
            END IF
            WINDOW
            XLAST = XMOUSE
            MOUSESHOW
            DO
                MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                IF XMOUSE <> XLAST THEN
                    XLAST = XMOUSE
                    IF XMOUSE > NLEFT + 1 THEN
                        MOUSEHIDE
                        ' ============================
                        ' = show JD range bar at top =
                        ' ============================
                        LINE (NX0, 35)-(NX1, NY0), NOFF, BF
                        LINE (NLEFT, 35)-(XMOUSE, NY0), NON, BF
                        MOUSESHOW
                        TUPLIM = TUPLIMIT * (XMOUSE - NX0) / NWIDE
                        X = TUPLIM / TR2 + .5
                        TUPLIM = TR2 * INT(X)
                        LOCATE 19, 6
                        PRINT USING FMT2$; DT0 + TUPLIM
                    END IF
                END IF
                IF MFLAG% = 0 THEN LBUT% = -1 - LBUT%
            LOOP UNTIL LBUT% = 0
            MOUSEHIDE
            IF TUPLIM > TUPLIMIT THEN TUPLIM = TUPLIMIT
        ' ==============================
        CASE 3                          ' time lower limit partial
            DTSPAN = TUPLIM - TLOLIM
            TCUR = TLOLIM
            PROMPT "RLOW"
            FMT2$ = "#######"
            NN = 3 - INT(LOG(DTSPAN) * TENLOG)
            IF NN > 0 THEN
                FMT2$ = FMT2$ + "." + STRING$(NN, 35)
            END IF
            WINDOW
            XLAST = XMOUSE
            MOUSESHOW
            DO
                MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                IF XMOUSE <> XLAST THEN
                    XLAST = XMOUSE
                    IF XMOUSE <= NX1 THEN
                        MOUSEHIDE
                        ' ===============================
                        ' = show JD range bar at bottom =
                        ' ===============================
                        LINE (NX0, NY1)-(NX1, 233), NOFF, BF
                        LINE (XMOUSE, NY1)-(NX1, 233), NON, BF
                        TCUR = TLOLIM + DTSPAN * (XMOUSE - NX0) / NWIDE
                        LOCATE 19, 6
                        PRINT USING FMT2$; DT0 + TCUR
                        MOUSESHOW
                    END IF
                END IF
                IF MFLAG% = 0 THEN LBUT% = -1 - LBUT%
            LOOP UNTIL LBUT% = 0
            MOUSEHIDE
            TLOLIM = TCUR
            IF TLOLIM < 0 THEN TLOLIM = 0
            IF TLOLIM > TUPLIM THEN TLOLIM = TUPLIM - 1
        ' ==============================
        CASE 4                          ' time upper limit partial
            DTSPAN = TUPLIM - TLOLIM
            TCUR = TUPLIM
            PROMPT "RUP "
            FMT2$ = "#######"
            NN = 3 - INT(LOG(DTSPAN) * TENLOG)
            IF NN > 0 THEN
                FMT2$ = FMT2$ + "." + STRING$(NN, 35)
            END IF
            WINDOW
            MOUSESHOW
            DO
                MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                IF XMOUSE <> XLAST THEN
                    XLAST = XMOUSE
                    IF XMOUSE >= NX0 THEN
                        MOUSEHIDE
                        ' ============================
                        ' = show JD range bar at top =
                        ' ============================
                        LINE (NX0, NY1)-(NX1, 233), NOFF, BF
                        LINE (0, NY1)-(XMOUSE, 233), NON, BF
                        TCUR = TLOLIM + DTSPAN * (XMOUSE - NX0) / NWIDE
                        LOCATE 19, 6
                        PRINT USING FMT2$; DT0 + TCUR
                        MOUSESHOW
                    END IF
                END IF
                IF MFLAG% = 0 THEN LBUT% = -1 - LBUT%
            LOOP UNTIL LBUT% = 0
            MOUSEHIDE
            TUPLIM = TCUR
            IF TUPLIM > TUPLIMIT THEN TUPLIM = TUPLIMIT
            IF TUPLIM < TLOLIM THEN TUPLIM = TLOLIM + 1
        ' ==============================
        CASE 5                          ' MAG bright limit entire
            MCUR = MA
            PROMPT "BRIT"
            MAGSPAN = MHIGH - MLOW
            WINDOW
            MOUSESHOW
            DO
                MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                IF YMOUSE <> YLAST THEN
                    YLAST = YMOUSE
                    MOUSEHIDE
                    ' ==============================
                    ' = show MAG range bar at left =
                    ' ==============================
                    LINE (10, NY0)-(NX0, NY1), NOFF, BF
                    LINE (10, YMOUSE)-(NX0, NBOTTOM), NON, BF
                    MCUR = MLOW + MAGSPAN * (YMOUSE - NY0) / NTALL
                    LOCATE 19, 6
                    PRINT USING FMT2$; MCUR
                    MOUSESHOW
                END IF
                IF MFLAG% = 0 THEN LBUT% = -1 - LBUT%
            LOOP UNTIL LBUT% = 0
            MOUSEHIDE
            MA = INT(10 * MCUR + .5) / 10
            IF MA < MLOW THEN MA = MLOW
        ' ==============================
        CASE 6                          ' MAG dim limit entire
            MCUR = MB
            PROMPT "DIM "
            MAGSPAN = MHIGH - MLOW
            WINDOW
            MOUSESHOW
            DO
                MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                IF YMOUSE <> YLAST THEN
                    YLAST = YMOUSE
                    MOUSEHIDE
                    ' ==============================
                    ' = show MAG range bar at left =
                    ' ==============================
                    LINE (10, NY0)-(NX0, NY1), NOFF, BF
                    LINE (10, NTOP)-(NX0, YMOUSE), NON, BF
                    MCUR = MLOW + MAGSPAN * (YMOUSE - NY0) / NTALL
                    LOCATE 19, 6
                    PRINT USING FMT2$; MCUR
                    MOUSESHOW
                END IF
                IF MFLAG% = 0 THEN LBUT% = -1 - LBUT%
            LOOP UNTIL LBUT% = 0
            MOUSEHIDE
            MB = INT(10 * MCUR + .5) / 10
            IF MB > MHIGH THEN MB = MHIGH
        ' ==============================
    END SELECT
    STATCOMP                            ' compute basic statistics
    SHOWRAW                             ' display the data
    END SUB

    SUB LOADRAW
    ' **************
    ' * SUBROUTINE *
    ' **************
LOADRA:
    FLOG$ = FIN$
    NX = INSTR(FLOG$, ".")
    IF NX < 1 THEN NX = LEN(FLOG$) + 1
    FLOG$ = LEFT$(FLOG$, NX - 1) + ".TS"
    PRINT "LOG file = "; FLOG$;
    LOCATE CSRLIN, 12
    GETNAME FLOG$, 0
    IF FLOG$ = ESC$ OR FLOG$ = NUL$ THEN FLOG$ = "TSERIES.LOG"
    CLOSE 1
    OPEN "A", 1, FLOG$
GETCOLUMN:
    ' ========================
    ' = create logfile title =
    ' ========================
    FILLY$ = "File=" + FIN$
    FILLY$ = LEFT$(FILLY$, 17)
    FILLY$ = FILLY$ + SPACE$(18 - LEN(FILLY$))
    ' =====================================
    ' = create root for utility filenames =
    ' =====================================
    ROOT$ = FIN$
    NX = INSTR(ROOT$, DOT$)
    IF NX > 1 THEN ROOT$ = LEFT$(ROOT$, NX - 1)
    ' ============================================
    ' = get columns for time, data, and observer =
    ' ============================================
    PRINT
    PRINT "Time column ="; NTCOL
    LOCATE CSRLIN - 1, 15: GETNAME ZZ$, 0
    NTCOL = VAL(ZZ$)
    IF NTCOL < 0 THEN NTCOL = 0
    PRINT "  X  column ="; NXCOL
    LOCATE CSRLIN - 1, 15: GETNAME ZZ$, 0
    NXCOL = VAL(ZZ$)
    IF NXCOL < 1 THEN NXCOL = 1
    PRINT "OBS  column =";
    IF NOCOL > 0 THEN
        PRINT NOCOL;
    END IF
    LOCATE CSRLIN, 15: GETNAME ZZ$, 0
    NOCOL = VAL(ZZ$)
    IF NOCOL < 0 THEN NOCOL = 0
    ' =======================================
    ' = get start, end time limits for load =
    ' =======================================
    PRINT
    PRINT "start time = "; JDA$
    LOCATE CSRLIN - 1, 14: GETNAME JDA$, -20
    JDA = VAL(JDA$)
    PRINT "  end time = "; JDB$
    LOCATE CSRLIN - 1, 14: GETNAME JDB$, -20
    JDB = VAL(JDB$)
    MA = 999999: MB = -999999           ' init low, high data values
    ' =======================================
    ' = set NMAXCOL to largest column value =
    ' =======================================
    NMAXCOL = NXCOL
    IF NTCOL > NMAXCOL THEN NMAXCOL = NTCOL
    IF NOCOL > NMAXCOL THEN NMAXCOL = NOCOL
    IF NTCOL = 0 THEN DT0 = 0
    PROMPT "LOAD"
    LOCATE 20, 1
    ' ==================
    ' = read data file =
    ' ==================
    OPEN "I", 9, FIN$
    DO UNTIL EOF(9)
        BREAKOUT
        IF NBRAKE < 0 THEN GOTO ALLDAT
        LINE INPUT #9, AREC$
        NUM = NUM + 1
        WVEC(NUM) = 0
        OBS(NUM) = NOOBS$
        NPARSEOK = 0
        IF NTCOL = 0 THEN TVEC(NUM) = NUM
        ' =============================
        ' = *do for necessary columns =
        ' =============================
        FOR N = 1 TO NMAXCOL
            PARSEREC AREC$, FEEL$
            ' ===================
            ' = *if time column =
            ' ===================
            IF N = NTCOL THEN
                IF NPARSEOK < 0 THEN
                    NUM = NUM - 1
                    GOTO NOTYET
                END IF
                DX = VAL(FEEL$)
                IF NUM = 1 THEN
                    IF DX < JDA THEN
                        NUM = 0: GOTO NOTYET
                    END IF
                    DT0 = INT(DX)
                END IF
                IF DX > JDB THEN
                    NUM = NUM - 1: GOTO ALLDAT
                END IF
                DX = DX - DT0
                TVEC(NUM) = DX
            END IF
            ' =====================
            ' = *if x-data column =
            ' =====================
            IF N = NXCOL THEN
                IF NPARSEOK < 0 THEN
                    NUM = NUM - 1
                    GOTO NOTYET
                END IF
                XVEC(NUM) = VAL(FEEL$)
            END IF
            ' =======================
            ' = *if observer column =
            ' =======================
            IF N = NOCOL THEN
                IF LEN(FEEL$) > 4 THEN FEEL$ = LEFT$(FEEL$, 4)
                IF LEN(FEEL$) < 4 THEN FEEL$ = FEEL$ + SPACE$(4 - LEN(FEEL$))
                OBS(NUM) = FEEL$
            END IF
        NEXT N
        IF XVEC(NUM) < MA THEN MA = XVEC(NUM)
        IF XVEC(NUM) > MB THEN MB = XVEC(NUM)
        WVEC(NUM) = 1
        IF TVEC(NUM) < TVEC(NUM - 1) THEN
            DX = TVEC(NUM): X = XVEC(NUM)
            FOR N = NUM - 1 TO 1 STEP -1
                IF DX >= TVEC(N) THEN GOTO GOESHERE
                TVEC(N + 1) = TVEC(N)
               XVEC(N + 1) = XVEC(N)
            NEXT N
            N = 0
GOESHERE:
            TVEC(N + 1) = DX: XVEC(N + 1) = X
        END IF
        NCO = NCO + 1
        IF NCO >= 10 THEN
            NCO = 0: PRINT BARRY$;
        END IF
        IF NUM >= NSIZ THEN
            PROMPT "FULL"
            GOTO ALLDAT
        END IF
NOTYET:
    LOOP
ALLDAT:
    ON ERROR GOTO 0
    MA = INT(MA) - 1: MB = INT(MB) + 2
    MLOW = MA: MHIGH = MB: MAGSPAN = MHIGH - MLOW
    IF NUM < 1 THEN
        PROMPT "NONE"
    ELSE
        NUMRAW = NUM
        IF TVEC(1) < 0 THEN
            DX = INT(-TVEC(1)) + 1
            DT0 = DT0 - DX
            FOR N = 1 TO NUM
                TVEC(N) = TVEC(N) + DX
            NEXT N
        END IF
        DTSPAN = TVEC(NUMRAW)           ' compute time span
        IF DTSPAN < 1 THEN DTSPAN = 1
        X = LOG(DTSPAN) * TENLOG        ' logten(timespan)
        X = INT(X - .5)                 ' int(that) - 1
        NDIGT = 7 - X                   ' #digits for time
        TRESOLV = 10 ^ X                ' time resolution for tick marks
        DD = INT(DT0 / TRESOLV) - 1     ' compute new DT0
        DD = DD * TRESOLV
        DTCORR = DT0 - DD               ' compute time correction
        DT0 = DD
        FOR N = 1 TO NUMRAW
            TVEC(N) = TVEC(N) + DTCORR
        NEXT N
        X = INT(TVEC(NUMRAW) / TRESOLV) + 2
        TUPLIMIT = X * TRESOLV
        TLOLIM = 0: TUPLIM = TUPLIMIT
        NLOLIM = 1: NUPLIM = NUMRAW
        TMARK = 0
        STATCOMP                        ' compute basic statistics
        CLS 2
        SHOWRAW                         ' plot the data
    END IF
    CLOSE 9
    END SUB

    SUB LOGNOW
    ' **************
    ' * SUBROUTINE *
    ' **************
    PRINT #1, FILLY$; "NUM=";
    PRINT #1, USING "#####"; NUMACT;
    PRINT #1, " AVE=";
    PRINT #1, USING FMT$; DAVE;
    PRINT #1, " SDV=";
    PRINT #1, USING FMT$; DSIG;
    PRINT #1, " VAR=";
    PRINT #1, USING FMT$; DVAR
    PRINT #1, "      JD ";
    PRINT #1, USING JDFORM$; DT0 + TVEC(NLOLIM);
    PRINT #1, "-";
    PRINT #1, USING JDFORM$; DT0 + TVEC(NUPLIM);
    PRINT #1, " T.AVE=";
    PRINT #1, USING JDFORM$; DT0 + DTZERO
    END SUB

    SUB MARKER
    ' **************
    ' * SUBROUTINE *
    ' **************
    IF TMARK > 0 THEN
        NXMARK = PMAP(TMARK, 0)
        NYMARK = PMAP(MAGMARK, 1)
        TPUT = PMAP(NXMARK - 6, 2)
        MPUT = PMAP(NYMARK - 6, 3)
        IF TPUT >= TLOLIM AND TPUT <= TUPLIM THEN
            IF MPUT >= MA AND MPUT <= MB THEN
                PUT (TPUT, MPUT), NYELLOW
            END IF
        END IF
    END IF
    TMARK = PMAP(XMOUSE, 2)
    MAGMARK = PMAP(YMOUSE, 3)
    TPUT = PMAP(XMOUSE - 6, 2)
    MPUT = PMAP(YMOUSE - 6, 3)
    IF TPUT >= TLOLIM AND TPUT <= TUPLIM THEN
        IF MPUT >= MA AND MPUT <= MB THEN
            PUT (TPUT, MPUT), NYELLOW
        ELSE
            TMARK = 0
            LOCATE 22, 46
            PRINT SPACE$(21);
        END IF
    ELSE
        TMARK = 0
        LOCATE 22, 46
        PRINT SPACE$(21);
    END IF
    END SUB

    SUB MATCHUP (NLX, NLY)
    ' **************
    ' * SUBROUTINE *
    ' **************
    FOR N1 = 1 TO 20                    ' *do for 20-pixel radius
        FOR N2 = 0 TO N1
            FOR N3 = -1 TO 1 STEP 2
                FOR N4 = -1 TO 1 STEP 2
                    NL1 = NLX + N3 * N1: NL2 = NLY + N4 * N2
                    MATCHZZ NL1, NL2, NT
                    IF NT <> 0 THEN GOTO MATCHING
                    NL1 = NLX + N3 * N2: NL2 = NLY + N4 * N1
                    MATCHZZ NL1, NL2, NT
                    IF NT <> 0 THEN GOTO MATCHING
                NEXT N4
            NEXT N3
        NEXT N2
    NEXT N1
    NL1 = NLX: NL2 = NLY
MATCHING:
    NLX = NL1: NLY = NL2
    END SUB

    SUB MATCHZZ (NL1, NL2, NT)
    ' **************
    ' * SUBROUTINE *
    ' **************
    NT = 0
    IF NL1 >= NX0 AND NL1 <= NX1 THEN
        IF NL2 > NY0 AND NL2 < NY1 THEN
            XX = PMAP(NL1, 2): YY = PMAP(NL2, 3)
            NT = POINT(XX, YY)
        END IF
    END IF
    END SUB

    SUB MATINV
    ' **************
    ' * SUBROUTINE *
    ' *   matrix   *
    ' *  inverse   *
    ' **************
    ' input:    DMAT    the matrix to be inverted
    ' output:   DMAT    the inverse of the input matrix
    DIM DSOL(0 TO NDIM, 0 TO NDIM)
    FOR NI = 0 TO NDIM                ' init solution to identity
        DSOL(NI, NI) = 1
    NEXT NI
    ' =============
    ' = main loop =
    ' =============
    FOR NI = 0 TO NDIM
        IF DMAT(NI, NI) = 0 THEN         ' if m(i,i) = 0 then
            IF NI = NDIM THEN GOTO DETZERO
            FOR NJ = NI + 1 TO NDIM     '    do each row after
                                        '       m(j,i) <> 0 ==> exit
                IF DMAT(NJ, NI) <> 0 THEN GOTO DETAOK
            NEXT NJ                     '    *enddo
DETZERO:
            EXIT SUB
DETAOK:
            FOR NK = 0 TO NDIM          '    do row I
                                        '       m(i,*)=m(i,*)+m(j,*)
                DMAT(NI, NK) = DMAT(NI, NK) + DMAT(NJ, NK)
                DSOL(NI, NK) = DSOL(NI, NK) + DSOL(NJ, NK)
            NEXT NK                     '    *enddo
        END IF
        DFAC = DMAT(NI, NI)
        FOR NJ = 0 TO NDIM              ' do row I
                                        '    m(i,*)=m(i,*)/m(i,i)
            DMAT(NI, NJ) = DMAT(NI, NJ) / DFAC
            DSOL(NI, NJ) = DSOL(NI, NJ) / DFAC
        NEXT NJ                         ' *enddo
        FOR NJ = 0 TO NDIM              ' do each row
            IF NJ <> NI THEN            '             (except row I)
                DFAC = DMAT(NJ, NI)
                FOR NK = 0 TO NDIM      '    do row J
                                        ' m(j,)=m(j,)-m(i,)*m(j,i)
                    DMAT(NJ, NK) = DMAT(NJ, NK) - DMAT(NI, NK) * DFAC
                    DSOL(NJ, NK) = DSOL(NJ, NK) - DSOL(NI, NK) * DFAC
                NEXT NK                 '    *enddo
            END IF
        NEXT NJ                         ' *enddo
    NEXT NI
    FOR NI = 0 TO NDIM
        FOR NJ = 0 TO NDIM
            DMAT(NI, NJ) = DSOL(NI, NJ)
        NEXT NJ
    NEXT NI
    ' =================
    ' = end main loop =
    ' =================
    END SUB

    SUB MOUSEHIDE
    ' **************
    ' * SUBROUTINE *
    ' **************
    IF MFLAG% THEN
        MOUSE 2, 0, 0, 0                ' hide the mouse
    ELSE
        N1 = XMOUSE - 6: N2 = YMOUSE - 6
        TPUT = PMAP(N1, 2): MPUT = PMAP(N2, 3)
        PUT (TPUT, MPUT), NYELLOW
    END IF
    END SUB

    SUB MOUSENOW (LBUT%, RBUT%, MBUT%, XM%, YM%) STATIC
    ' Returns the instantaneous state of the mouse.
    ' PARAMETERS:    LBUT%   Indicates left mouse button state
    '                RBUT%  Indicates right mouse button state
    '                XMOUSE       X location of mouse
    '                YMOUSE       Y location of mouse
    KSEL$ = NUL$
    IF MFLAG% THEN
        MOUSE 3, M2%, XM%, YM%
        LBUT% = ((M2% AND 1) <> 0)
        RBUT% = ((M2% AND 2) <> 0)
        MBUT% = ((M2% AND 4) <> 0)
        KSEL$ = INKEY$
        IF KSEL$ <> NUL$ THEN
            DO: KK$ = INKEY$: LOOP UNTIL KK$ = NUL$
        END IF
    ELSE
        K$ = INKEY$
        LBUT% = 0
        RBUT% = 0
        IF K$ <> NUL$ THEN
            DO: KK$ = INKEY$: LOOP UNTIL KK$ = NUL$
            MOUSEHIDE
            SELECT CASE K$
                ' ======================
                CASE LARR$
                    XMOUSE = XMOUSE - 1
                ' ======================
                CASE CTLA$
                    XMOUSE = XMOUSE - 10
                ' ======================
                CASE RARR$
                    XMOUSE = XMOUSE + 1
                ' ======================
                CASE CTRA$
                    XMOUSE = XMOUSE + 10
                ' ======================
                CASE UARR$
                    YMOUSE = YMOUSE - 1
                ' ======================
                CASE UPAG$
                    YMOUSE = YMOUSE - 10
                ' ======================
                CASE DARR$
                    YMOUSE = YMOUSE + 1
                ' ======================
                CASE DPAG$
                    YMOUSE = YMOUSE + 10
                ' ======================
                CASE HOME$
                    XMOUSE = 6
                ' ======================
                CASE EEND$
                    XMOUSE = 633
                ' ======================
                CASE CR$
                    LBUT% = -1
                ' ======================
                CASE BACK$
                    RBUT% = -1
                ' ======================
                CASE ELSE
                    KSEL$ = K$
                ' ======================
            END SELECT
            IF XMOUSE < 6 THEN XMOUSE = 6
            IF XMOUSE > 633 THEN XMOUSE = 633
            IF YMOUSE < 6 THEN YMOUSE = 6
            IF YMOUSE > 240 THEN YMOUSE = 240
            MOUSESHOW
        END IF
    END IF
    ' ======================
    ' = begin click decode =
    ' = **NOTE** this code =
    ' = has been moved from=
    ' = the main routine   =
    ' ======================
    IF RBUT% < 0 THEN
        KSEL$ = BACK$
    END IF
    IF MBUT% < 0 THEN
        KSEL$ = "B"
    END IF
    IF LBUT% < 0 THEN
        KSEL$ = NUL$
        SELECT CASE YMOUSE
            ' ==================
            CASE 0 TO 12
                IF XMOUSE > 247 AND XMOUSE < 361 THEN
                    KSEL$ = F1$
                END IF
            ' ==================
            CASE 13 TO NY0      ' time axis
                SELECT CASE XMOUSE
                    ' ==========  lower limit
                    CASE NLEFT - 10 TO NLEFT + 10
                        KSEL$ = "L"
                        NEGF = 1
                    ' ==========  upper limit
                    CASE NRIGHT - 10 TO NRIGHT + 10
                        KSEL$ = "L"
                        NEGF = 2
                    ' ==========
                    CASE ELSE
                        GOTO CHANCY
                END SELECT
            ' ==================
            CASE NY1 TO NYALL   ' lower time axis
                SELECT CASE XMOUSE
                    CASE NX0 - 10 TO NX0 + 10
                        KSEL$ = "L"
                        NEGF = 3
                    CASE NX1 - 10 TO NX1 + 10
                        KSEL$ = "L"
                        NEGF = 4
                    CASE ELSE
                        GOTO CHANCY
                END SELECT
            ' ==================
            CASE 254 TO 263     ' prompt line 1
                SELECT CASE XMOUSE
                    CASE 0 TO 38
                        KSEL$ = ESC$
                    CASE 161 TO 300
                        KSEL$ = F5$
                    CASE 321 TO 460
                        KSEL$ = "M"
                    CASE 481 TO 520
                        KSEL$ = "P"
                END SELECT
            ' ==================
            CASE 267 TO 276
                SELECT CASE XMOUSE
                    CASE 0 TO 140
                        KSEL$ = F1$
                    CASE 161 TO 300
                        KSEL$ = F6$
                    CASE 321 TO 460
                        KSEL$ = "C"
                    CASE 481 TO 520
                        KSEL$ = "S"
                END SELECT
            ' ==================
            CASE 282 TO 291
                SELECT CASE XMOUSE
                    CASE 0 TO 140
                        KSEL$ = F2$
                    CASE 161 TO 300
                        KSEL$ = F7$
                END SELECT
            ' ==================
            CASE 296 TO 305
                SELECT CASE XMOUSE
                    CASE 0 TO 140
                        KSEL$ = F3$
                    CASE 161 TO 300
                        KSEL$ = F8$
                END SELECT
            ' ==================
            CASE 310 TO 319
                SELECT CASE XMOUSE
                    CASE 0 TO 140
                        KSEL$ = F4$
                    CASE 161 TO 300
                        KSEL$ = F9$
                END SELECT
            ' ==================
            CASE ELSE
CHANCY:
                SELECT CASE XMOUSE
                    ' ==========
                    CASE 0 TO NX0 - 1
                        SELECT CASE YMOUSE
                            ' ==========
                            CASE NTOP - 10 TO NTOP + 10
                                NEGF = 5
                                KSEL$ = "L"
                            ' ==========
                            CASE NBOTTOM - 10 TO NBOTTOM + 10
                                NEGF = 6
                                KSEL$ = "L"
                            ' ==========
                        END SELECT
                    ' ==========
                    CASE ELSE
                        KSEL$ = CR$
                END SELECT
            ' ==================
        END SELECT
    END IF
    ' ====================
    ' = end click decode =
    ' ====================
    END SUB

    SUB MOUSESHOW
    ' **************
    ' * SUBROUTINE *
    ' **************
    IF MFLAG% THEN
        MOUSE 1, 0, 0, 0                ' show the mouse
    ELSE
        N1 = XMOUSE - 6: N2 = YMOUSE - 6
        TPUT = PMAP(N1, 2): MPUT = PMAP(N2, 3)
        PUT (TPUT, MPUT), NYELLOW
    END IF
    END SUB

    SUB PARSEREC (AREC$, FEEL$)
    ' **************
    ' * SUBROUTINE *
    ' *parse record*
    ' **************
    FEEL$ = NUL$
    NPARSEOK = 0
    AREC$ = LTRIM$(AREC$)
    IF LEN(AREC$) < 1 THEN
        DX = 0
        NPARSEOK = -1
        EXIT SUB
    END IF
    NDIG = 0
    NX = INSTR(AREC$, BL$)
    IF NX = 0 THEN NX = INSTR(AREC$, ",")
    IF NX > 0 THEN
        FEEL$ = LEFT$(AREC$, NX - 1)
        AREC$ = RIGHT$(AREC$, LEN(AREC$) - NX)
    ELSE
        FEEL$ = AREC$: AREC$ = NUL$
    END IF
    FEEL$ = RTRIM$(LTRIM$(FEEL$))
    FOR N = 1 TO LEN(FEEL$)
        T$ = MID$(FEEL$, N, 1)
        IF T$ >= "0" AND T$ <= "9" THEN
            NDIG = NDIG + 1             ' count # digits
            GOTO PARSEOK
        END IF
        IF T$ = BL$ THEN GOTO PARSEOK
        IF T$ = "+" OR T$ = "-" OR T$ = "." THEN GOTO PARSEOK
        NPARSEOK = -1
        EXIT SUB
PARSEOK:
    NEXT N
    IF NDIG < 1 THEN
        NPARSEOK = -1
    END IF
    END SUB

    SUB POINTID
    ' **************
    ' * SUBROUTINE *
    ' * point I.D. *
    ' **************
    NTEST = POINT(TCUR, MCUR)
    IF NTEST = 0 THEN
        MATCHUP XMOUSE, YMOUSE
        TCUR = PMAP(XMOUSE, 2)
        MCUR = PMAP(YMOUSE, 3)
    END IF
    FOR NTHIS = NLOLIM TO NUPLIM
        NXX = PMAP(TVEC(NTHIS), 0)
        IF NXX > XMOUSE THEN
            NTHIS = 0: GOTO GOTPOINT
        END IF
        IF NXX = XMOUSE THEN
            NYY = PMAP(XVEC(NTHIS), 1)
            IF NYY = YMOUSE THEN GOTO GOTPOINT
        END IF
    NEXT NTHIS
    NTHIS = 0
GOTPOINT:
    IF NTHIS > 0 THEN
        TCUR = TVEC(NTHIS): MCUR = XVEC(NTHIS)
        NACTUAL = -1        ' flag ACTUAL data
        FMT2$ = JDFORM$
    ELSE
        NACTUAL = 0         ' flag NOT ACTUAL data
        FMT2$ = FMT$
        IF LEN(FMT2$) < 12 THEN
            FMT2$ = FMT2$ + SPACE$(12 - LEN(FMT2$))
        END IF
    END IF
    ' ========================
    ' = locate actual record =
    ' ========================
        LOCATE 22, 46: PRINT USING FMT2$; TCUR + DT0;
        PRINT USING " ###.####"; MCUR;
        PRINT BL$; OBS(NTHIS); BL$;
    IF MFLAG% THEN
        XMOUSE = PMAP(TCUR, 0)
        YMOUSE = PMAP(MCUR, 1)
        MOUSE 4, 0, XMOUSE, YMOUSE      ' position mouse
    END IF
    END SUB

    SUB POLYDERIV (DTIME, DV1, DV2, DV3)
    ' *************
    ' * SUBOUTINE *
    ' *************
    DT = (DTIME - DTZERO) / DTSCALE
    DV1 = DCOEF(1) + 2 * DCOEF(2) * DT
    DV2 = 2 * DCOEF(2)
    DV3 = 0
    FOR N = 3 TO NDIM
        DV1 = DV1 + N * DCOEF(N) * DT ^ (N - 1)
        DV2 = DV2 + N * (N - 1) * DCOEF(N) * DT ^ (N - 2)
        DV3 = DV3 + N * (N - 1) * (N - 2) * DCOEF(N) * DT ^ (N - 3)
    NEXT N
    DV1 = DV1 / DTSCALE
    DV2 = DV2 / DTSCALE ^ 2
    DV3 = DV3 / DTSCALE ^ 3
    END SUB

    SUB POLYFIT
    ' ******************
    ' *   SUBROUTINE   *
    ' * fit polynomial *
    ' ******************
    DIM DZETA(0 TO 100)
    CLS 2
    NFRE = 0
    ' NBIAS = 0
    PROJECT
    ' ====================================================
    ' = compute coefficients for uncertainty calculation =
    ' ====================================================
    FOR N1 = 0 TO NPOLY
        D1 = DMAT(0, N1): D2 = DMAT(NPOLY - N1, NPOLY)
        FOR N2 = 1 TO N1
            D1 = D1 + DMAT(N2, N1 - N2)
            D2 = D2 + DMAT(NPOLY - N1 + N2, NPOLY - N2)
        NEXT N2
        DZETA(N1) = D1: DZETA(2 * NPOLY - N1) = D2
    NEXT N1
    ' ===========================
    ' = compute and plot points =
    ' ===========================
    TSPAN = TVEC(NUPLIM) - TVEC(NLOLIM)
    NT = INT(LOG(TSPAN) * TENLOG) - 2
    TT = 10 ^ (NT)
    NUMRED = 0
    X = TVEC(NLOLIM) / TT: X = TT * (INT(X) + 1)
    XX = TVEC(NUPLIM)
    FOR DTIME = X TO XX STEP TT
        SMOOTH DTIME, DX
        NUMRED = NUMRED + 1
        TFIT(NUMRED) = DTIME: XFIT(NUMRED) = DX
        IF NUMRED > 1 THEN
            LINE -(TFIT(NUMRED), XFIT(NUMRED)), 12
        ELSE
            PSET (TFIT(NUMRED), XFIT(NUMRED)), 12
        END IF
        ' =======================
        ' = compute uncertainty =
        ' =======================
        DT = (DTIME - DTZERO) / DTSCALE
        'DU = DZETA(2 * NPOLY)
        'FOR N1 = 2 * NPOLY - 1 TO 0 STEP -1
        '    DU = DU * DT + DZETA(N1)
        'NEXT N1
        'IF DU < 0 THEN DU = 0
        'SFIT(NUMRED) = SQR(DU)
    NEXT DTIME
    END SUB

    SUB POLYMAST
    ' **************
    ' * SUBROUTINE *
    ' * polynomial *
    ' *   master   *
    ' **************
    DIM TTEMP(10)
    STATCOMP
    N2DO = 1                           ' max # recursions for multilinear
    IF KSEL$ <> F6$ THEN
        KSEL$ = F3$
    ELSE
        N2DO = 9
    END IF
    GOTO POLYIN
    DO
        PROMPT "POLY"
        LOCATE 24, 1: PRINT "Degree="; NPOLY;
        LOCATE 24, 20: PRINT "Power= ";
        PRINT USING FMT$; DPOWER;
        MOUSESHOW
        DO
            MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
        LOOP UNTIL KSEL$ = NUL$
        DO
            MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
        LOOP WHILE KSEL$ = NUL$
        MOUSEHIDE
POLYIN:
        SELECT CASE KSEL$
            ' ==========================
            CASE F3$                    ' fit polynomial degree NPOLY
DIMIN:
                CLS 2
                PRINT "Degree ="; NPOLY
                LOCATE 19, 10: GETNAME ZZ$, 0
                IF ZZ$ = ESC$ THEN EXIT SUB
                NPOLY = VAL(ZZ$)
                IF NPOLY < 0 OR NPOLY > 50 THEN
                    ' BEEP
                    GOTO DIMIN
                END IF
                POLYFIT
                ' ==============================
                ' = estimate residual variance =
                ' ==============================
                DS9 = DVAR * (NUMACT - 1 - NPOLY * DPOWER)
                DS9 = DS9 / (NUMACT - 1) / (NUMACT - 1 - NPOLY)
                IF DS9 < 0 THEN DS9 = 0
                DS9 = SQR(DS9)
                PRINT USING FMT$; DS9;
                PRINT #1, "POLY";
                IF NPOLY > 9 THEN
                    PRINT #1, USING "##"; NPOLY;
                ELSE
                    PRINT #1, USING "#"; NPOLY;
                END IF
                PRINT #1, USING FMT$; DPOWER; DS9;
                PRINT #1, BL$;
                LOGNOW
            ' ==========================
            CASE F2$                    ' save to file
                PRINT #1, "POLY DEGREE" + STR$(NPOLY)
                LOGNOW
                PRINT #1, "***POWER= "; DPOWER
                FOR N = 1 TO NUMRED
                    PRINT #1, USING JDFORM$; TFIT(N) + DT0;
                    PRINT #1, USING FMT$; XFIT(N); DS9 * SFIT(N)
                NEXT N
            ' ==========================
            CASE F1$                    ' save constants to log file
                PRINT #1, "POLY COEFFICIENTS"
                LOGNOW
                PRINT #1, "Time0= ";
                PRINT #1, USING JDFORM$; DTZERO + DT0
                PRINT #1, "Power= "; DPOWER
                FOR N = 0 TO NPOLY
                    DCC = DCOEF(N) / DTSCALE ^ N
                    PRINT #1, N;
                    PRINT #1, DCC
                NEXT N
                FOR N = 1 TO NBIAS
                    PRINT #1, OBIAS(N); BL$;
                    PRINT #1, DCOEF(NPOLY + N)
                NEXT N
            ' ==========================
            CASE F4$                    ' save residuals to file
                FTMP$ = ROOT$ + ".RES"
                LOCATE 24, 1
                PRINT "File = "; FTMP$; SPACE$(10);
                LOCATE 24, 8: GETNAME FTMP$, 0
                OPEN "O", 9, FTMP$
                FOR N = NLOLIM TO NUPLIM
                    IF WVEC(N) > 0 THEN
                        DTIME = TVEC(N)
                        SMOOTH DTIME, DX
                        RES = XVEC(N) - DX
                        FOR NB = 1 TO NBIAS
                            IF OBS(N) = OBIAS(NB) THEN
                                RES = RES - DCOEF(NPOLY + NB)
                            END IF
                        NEXT NB
                        PRINT #9, USING JDFORM$; TVEC(N) + DT0;
                        PRINT #9, USING FMT$; RES;
                        IF OBS(N) = NOOBS$ THEN
                            PRINT #9,
                        ELSE
                            PRINT #9, BL$; OBS(N)
                        END IF
                    END IF
                NEXT N
                CLOSE 9
            ' ==========================
            CASE F5$                    ' locate central MAX/MIN
                PROMPT "PMAX"
                MOUSESHOW
                DO
                    MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                LOOP UNTIL LBUT% = 0
                DO
                    MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                    IF LBUT% < 0 THEN
                        TTT = PMAP(XMOUSE, 2)
                    END IF
                LOOP UNTIL LBUT% < 0
                MOUSEHIDE
                PRINT #1, "POLY"; STR$(NPOLY); " EXTREMUM ";
                LOGNOW
                FOR N = 1 TO NUMRED
                    IF TFIT(N) > TTT THEN GOTO GOTMAX
                NEXT N
GOTMAX:
                DTIME = TFIT(N)
                POLYDERIV DTIME, DV1, DV2, DV3
                NTYPE = 1               ' look for MAX
                IF DV2 < 0 THEN NTYPE = -1 ' look for MIN
                DO
                    IF NTYPE * (XFIT(N) - XFIT(N + 1)) > 0 THEN
                        N = N + 1
                    ELSE
                        IF NTYPE * (XFIT(N) - XFIT(N - 1)) > 0 THEN
                            N = N - 1
                        ELSE
                            DTIME = TFIT(N)
                            DO
                                POLYDERIV DTIME, DV1, DV2, DV3
                                DV1 = DV1 / DV2
                                DTIME = DTIME - DV1
                            LOOP UNTIL ABS(DV1) < .0001
                            SMOOTH DTIME, DX
                            POLYDERIV DTIME, DV1, DV2, DV3
                            ' ============================
                            ' = set marker on this point =
                            ' ============================
                            TMARK = DTIME: MAGMARK = DX
                            NX = PMAP(DTIME, 0)
                            NY = PMAP(DX, 1)
                            TPUT = PMAP(NX - 6, 2)
                            MPUT = PMAP(NY - 6, 3)
                            IF TPUT >= TLOLIM AND TPUT <= TUPLIM THEN
                                IF MPUT >= MA AND MPUT <= MB THEN
                                    PUT (TPUT, MPUT), NYELLOW
                                END IF
                            END IF
                            ' =======================
                            ' = compute uncertainty =
                            ' =======================
                            'DU = 0
                            DT = (DTIME - DTZERO) / DTSCALE
                            DTAU = 0
                            FOR NA = 0 TO NPOLY
                                FOR NB = 0 TO NPOLY
                                    'DU = DU + DMAT(NA, NB) * DT ^ (NA + NB)
                DTAU = DTAU + NA * NB * DMAT(NA, NB) * DT ^ (NA + NB - 2)
                                NEXT NB
                            NEXT NA
                            'DU = SQR(DU)
                            'DU = DU * DS9
                            DTAU = DTAU / DV2 ^ 2
                            DTAU = SQR(DTAU) * DS9 / DTSCALE
                            PRINT #1, USING JDFORM$; DT0 + DTIME;
                            PRINT #1, USING FMT$; DX;
                            PRINT #1, " +-";
                            PRINT #1, USING FMT$; DTAU; DU;
                            PRINT #1, USING FMT$; 100 * DV2; 1000 * DV3;
                            PRINT #1, " =CRIT"
                            N = 0
                        END IF
                    END IF
                LOOP UNTIL N <= 1 OR N >= NUMRED
            ' ==========================
            CASE F6$                    ' multi-linear fit
                NTEMPSAV = NTEMP
                NTEMP = 0
                PROMPT "MLIN"
                MOUSESHOW
                DO
                    MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                    IF LBUT% < 0 THEN
                        DO
                            MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                        LOOP UNTIL LBUT% = 0
                        NTEMP = NTEMP + 1
                        TTEMP(NTEMP) = PMAP(XMOUSE, 2)
                        MOUSEHIDE
                        LINE (TTEMP(NTEMP), MA)-(TTEMP(NTEMP), MB), 15
                        MOUSESHOW
                    END IF
                LOOP UNTIL RBUT% < 0 OR NTEMP > 8
                MOUSEHIDE
                LOCATE 24, 1
                PRINT "AOK? Y";
                GETRESP YN$
                SHOWRAW
                IF YN$ = YES$ THEN
                    PRINT #1, "MULTILINEAR ";
                    LOGNOW
                    IF NTEMP = 0 THEN NTEMP = NTEMPSAV
                    NPOLY = 1
                    TLOSAV = TLOLIM
                    TUPSAV = TUPLIM
                    TTEMP(0) = TLOLIM
                    TTEMP(NTEMP + 1) = TUPLIM
                    FOR NRECUR = 1 TO N2DO
                        BREAKOUT
                        IF NBRAKE < 0 THEN NRECUR = N2DO
                        MISS = 0
                        IF NRECUR = N2DO THEN
                            TLOLIM = TLOSAV
                            SHOWRAW
                        END IF
                        DO
                            NCHANG = 0
                            FOR N = 1 TO NTEMP
                                IF TTEMP(N) > TTEMP(N + 1) THEN
                                    SWAP TTEMP(N), TTEMP(N + 1)
                                    NCHANG = 1
                                END IF
                            NEXT N
                        LOOP UNTIL NCHANG = 0
                        FOR N = 0 TO NTEMP
                            ' ==================================
                            ' = set time limits for regression =
                            ' ==================================
                            TLOLIM = TTEMP(N)
                            TUPLIM = TTEMP(N + 1)
                            STATCOMP        ' set NLOLIM and NUPLIM
                            IF NUMACT < 2 THEN
                                PROMPT "MLIE"
                                GETNAME ZZ$, 0
                                GOTO POLYOUT
                            END IF
                            POLYFIT
                            IF NRECUR = N2DO AND N = 0 THEN
                                TTEMP(N) = TFIT(1)
                                MLAST = XFIT(1)
                                PRINT #1, USING JDFORM$; DT0 + TFIT(1);
                                PRINT #1, USING FMT$; XFIT(1)
                                NXMARK = PMAP(TFIT(1), 0)
                                NYMARK = PMAP(XFIT(1), 1)
                                TPUT = PMAP(NXMARK - 6, 2)
                                MPUT = PMAP(NYMARK - 6, 3)
                                IF TPUT >= TLOSAV AND TPUT <= TUPSAV THEN
                                    IF MPUT >= MA AND MPUT <= MB THEN
                                        PUT (TPUT, MPUT), NYELLOW
                                    END IF
                                END IF
                            END IF
                            A1 = A2: B1 = B2: TAU1 = TAU2
                            A2 = DCOEF(1) / DTSCALE
                            B2 = DCOEF(0)
                            TAU2 = DTZERO
                            IF N > 0 THEN
                                ' =================================
                                ' = compute intersection of lines =
                                ' =================================
                                TPUT = B1 - B2 - A1 * TAU1 + A2 * TAU2
                                TPUT = TPUT / (A2 - A1)
                                MPUT = B2 + A2 * (TPUT - TAU2)
                                X = ABS(TPUT - TTEMP(N))
                                IF X > MISS THEN MISS = X
                                TTEMP(N) = TPUT
                                IF NRECUR = N2DO THEN
                                    PRINT #1, USING JDFORM$; DT0 + TPUT;
                                    PRINT #1, USING FMT$; MPUT;
                                    XDELTA = TTEMP(N) - TTEMP(N - 1)
                                    XDELTAM = MPUT - MLAST
                                    PRINT #1, USING FMT$; XDELTA;
                                    PRINT #1, USING FMT$; XDELTAM;
                                    PRINT #1, USING FMT$; XDELTAM / XDELTA;
                                    PRINT #1, " *OUT"
                                    MLAST = MPUT
                                END IF
                                NXMARK = PMAP(TPUT, 0)
                                NYMARK = PMAP(MPUT, 1)
                                TPUT = PMAP(NXMARK - 6, 2)
                                MPUT = PMAP(NYMARK - 6, 3)
                                IF TPUT >= TLOSAV AND TPUT <= TUPSAV THEN
                                    IF MPUT >= MA AND MPUT <= MB THEN
                                        PUT (TPUT, MPUT), NYELLOW
                                    END IF
                                END IF
                            END IF
                            IF NRECUR = N2DO AND N = NTEMP THEN
                                PRINT #1, USING JDFORM$; DT0 + TFIT(NUMRED);
                                PRINT #1, USING FMT$; XFIT(NUMRED);
                                XDELTA = TFIT(NUMRED) - TTEMP(N)
                                XDELTAM = XFIT(NUMRED) - MLAST
                                PRINT #1, USING FMT$; XDELTA;
                                PRINT #1, USING FMT$; XDELTAM;
                                PRINT #1, USING FMT$; XDELTAM / XDELTA
                                NXMARK = PMAP(TFIT(NUMRED), 0)
                                NYMARK = PMAP(XFIT(NUMRED), 1)
                                TPUT = PMAP(NXMARK - 6, 2)
                                MPUT = PMAP(NYMARK - 6, 3)
                                IF TPUT >= TLOSAV AND TPUT <= TUPSAV THEN
                                    IF MPUT >= MA AND MPUT <= MB THEN
                                        PUT (TPUT, MPUT), NYELLOW
                                    END IF
                                END IF
                            END IF
                        NEXT N
    IF MISS < .001 AND NRECUR < N2DO THEN NRECUR = N2DO - 1
                    NEXT NRECUR
                    IF MISS > .001 THEN
                        PRINT #1, "LAST STEP =";
                        PRINT #1, USING FMT$; MISS
                    END IF
POLYOUT:
                    TLOLIM = TLOSAV
                    TUPLIM = TUPSAV
                    STATCOMP
                END IF
                KSEL$ = ESC$
        END SELECT
    LOOP UNTIL KSEL$ = ESC$
    END SUB

    SUB PROJECT
    ' **************
    ' * SUBROUTINE *
    ' **************
    ' perform function-space projection
    ' ====================
    ' = temporary arrays =
    ' ====================
    DIM DPOW(NPOLY)                     ' powers of time
    DIM DRAD(NFRE)                      ' radian frequencies
    DIM DCC(NFRE)                       ' cosines
    DIM DSS(NFRE)                       ' sines
    ' =========
    ' = begin =
    ' =========
    BREAKOUT
    NDIM2 = NPOLY + 2 * NFRE
    NDIM = NDIM2 + NBIAS
    DWEIGHT = 0
    FOR N1 = 0 TO NDIM
        DVEC(N1) = 0
        FOR N2 = 0 TO NDIM
            DMAT(N1, N2) = 0
        NEXT N2
    NEXT N1
    FOR NF = 1 TO NFRE
        IF DFRE(NF) < DANGCUT THEN
            DFPOW = 0: DPOWER = 0
            EXIT SUB
        END IF
        DRAD(NF) = TWOPI * DFRE(NF) * DTSCALE
        FOR NF2 = NF + 1 TO NFRE
            IF ABS(DFRE(NF) - DFRE(NF2)) < .00000001# THEN
                DPOWER = 0
                EXIT SUB
            END IF
        NEXT NF2
    NEXT NF
    DPOW(0) = 1
    ' ===========================
    ' = main loop for summation =
    ' ===========================
    FOR N = NLOLIM TO NUPLIM
        IF WVEC(N) > 0 THEN             ' *if good data then
            ' DW = WVEC(N)                '   weight
            ' DWEIGHT = DWEIGHT + DW
            DWEIGHT = DWEIGHT + 1       ' **
            DT = TVEC(N)
            DT = (DT - DTZERO) / DTSCALE
            DX = XVEC(N)
            ' DX = DW * DX
            ' ==========================
            ' = compute powers of time =
            ' ==========================
            FOR NP = 1 TO NPOLY
                DPOW(NP) = DPOW(NP - 1) * DT
            NEXT NP
            ' ==========================
            ' = compute trig functions =
            ' ==========================
            FOR NF = 1 TO NFRE
                DPHASE = DRAD(NF) * DT
                DCC(NF) = COS(DPHASE)
                DSS(NF) = SIN(DPHASE)
            NEXT NF
            ' ===============================
            ' = compute matrix coefficients =
            ' =       for polynomials       =
            ' ===============================
            FOR NP = 0 TO NPOLY
                ' DMAT(0, NP) = DMAT(0, NP) + DW * DPOW(NP)
                DMAT(0, NP) = DMAT(0, NP) + DPOW(NP) ' **
                IF NP > 0 THEN
    ' DMAT(NP, NPOLY) = DMAT(NP, NPOLY) + DW * DPOW(NP) * DPOW(NPOLY)
    DMAT(NP, NPOLY) = DMAT(NP, NPOLY) + DPOW(NP) * DPOW(NPOLY) ' **
                END IF
                DVEC(NP) = DVEC(NP) + DX * DPOW(NP)
                N2 = NPOLY
                ' ===================================
                ' = and for products of polynomials =
                ' =       with trig functions       =
                ' ===================================
                FOR NF = 1 TO NFRE
                    N2 = N2 + 2
    ' DMAT(NP, N2 - 1) = DMAT(NP, N2 - 1) + DW * DPOW(NP) * DCC(NF)
    DMAT(NP, N2 - 1) = DMAT(NP, N2 - 1) + DPOW(NP) * DCC(NF) ' **
    ' DMAT(NP, N2) = DMAT(NP, N2) + DW * DPOW(NP) * DSS(NF)
    DMAT(NP, N2) = DMAT(NP, N2) + DPOW(NP) * DSS(NF) ' **
                NEXT NF
            NEXT NP
            ' ==============================
            ' = compute matrix values for  =
            ' = products of trig functions =
            ' ==============================
            N1 = NPOLY
            FOR NF = 1 TO NFRE
                N2 = N1
                N1 = N1 + 2
                DVEC(N1 - 1) = DVEC(N1 - 1) + DX * DCC(NF)
                DVEC(N1) = DVEC(N1) + DX * DSS(NF)
                FOR NF2 = NF TO NFRE
                    N2 = N2 + 2
' DMAT(N1 - 1, N2 - 1) = DMAT(N1 - 1, N2 - 1) + DW * DCC(NF) * DCC(NF2)
DMAT(N1 - 1, N2 - 1) = DMAT(N1 - 1, N2 - 1) + DCC(NF) * DCC(NF2) ' **
' DMAT(N1 - 1, N2) = DMAT(N1 - 1, N2) + DW * DCC(NF) * DSS(NF2)
DMAT(N1 - 1, N2) = DMAT(N1 - 1, N2) + DCC(NF) * DSS(NF2) ' **
    ' DMAT(N1, N2 - 1) = DMAT(N1, N2 - 1) + DW * DSS(NF) * DCC(NF2)
    DMAT(N1, N2 - 1) = DMAT(N1, N2 - 1) + DSS(NF) * DCC(NF2) ' **
    ' DMAT(N1, N2) = DMAT(N1, N2) + DW * DSS(NF) * DSS(NF2)
    DMAT(N1, N2) = DMAT(N1, N2) + DSS(NF) * DSS(NF2) ' **
                NEXT NF2
            NEXT NF
            ' ==============================
            ' = compute matrix entries for =
            ' =  observer bias functions   =
            ' ==============================
            FOR NB = 1 TO NBIAS
                IF OBS(N) = OBIAS(NB) THEN
                    N2 = NDIM2 + NB
                    ' DMAT(N2, N2) = DMAT(N2, N2) + DW
                    DMAT(N2, N2) = DMAT(N2, N2) + 1 ' **
                    DVEC(N2) = DVEC(N2) + DX
                    FOR NP = 0 TO NPOLY
                        ' DMAT(NP, N2) = DMAT(NP, N2) + DW * DPOW(NP)
                        DMAT(NP, N2) = DMAT(NP, N2) + DPOW(NP) ' **
                    NEXT NP
                    N1 = NPOLY
                    FOR NF = 1 TO NFRE
                        N1 = N1 + 2
    ' DMAT(N1 - 1, N2) = DMAT(N1 - 1, N2) + DW * DCC(NF)
    DMAT(N1 - 1, N2) = DMAT(N1 - 1, N2) + DCC(NF) ' **
                        ' DMAT(N1, N2) = DMAT(N1, N2) + DW * DSS(NF)
                        DMAT(N1, N2) = DMAT(N1, N2) + DSS(NF) ' **
                    NEXT NF
                END IF
            NEXT NB
        END IF                          ' *endif
    NEXT N
    ' ==========================
    ' = end loop for summation =
    ' ==========================
    ' ===================================
    ' = check for absent BIAS observers =
    ' ===================================
    FOR N = 1 TO NBIAS
        IF DMAT(NDIM2 + N, NDIM2 + N) < 1 THEN
            PRINT #1, ARROW$
            PRINT #1, ARROW$; "Absent BIAS Obs: ";
            PRINT #1, OBIAS(N)
            PRINT #1, ARROW$
            NDIM = NDIM2
            NBIAS = 0
        END IF
    NEXT N
    FOR N1 = 1 TO NPOLY - 1
        FOR N2 = N1 TO NPOLY - 1
            DMAT(N1, N2) = DMAT(N1 - 1, N2 + 1)
        NEXT N2
    NEXT N1
    FOR N1 = 0 TO NDIM
        DVEC(N1) = DVEC(N1) / DWEIGHT
        FOR N2 = N1 TO NDIM
            DMAT(N1, N2) = DMAT(N1, N2) / DWEIGHT
        NEXT N2
    NEXT N1
    DMAT(0, 0) = 1
    FOR N1 = 1 TO NDIM
        FOR N2 = 0 TO N1 - 1
            DMAT(N1, N2) = DMAT(N2, N1)
        NEXT N2
    NEXT N1
    MATINV
    DAMP2 = 0
    FOR N1 = 0 TO NDIM
        DCOEF(N1) = 0
        FOR N2 = 0 TO NDIM
            DCOEF(N1) = DCOEF(N1) + DMAT(N1, N2) * DVEC(N2)
        NEXT N2
        DAMP2 = DAMP2 + DCOEF(N1) * DVEC(N1)
    NEXT N1
    DAMP2 = DAMP2 - DAVE ^ 2
    IF DAMP2 < 0 THEN DAMP2 = 0
    IF NDIM > 0 THEN
        DPOWER = (NUMACT - 1) * DAMP2 / DVAR / NDIM
    ELSE
        DPOWER = 0
    END IF
    ' ================================
    ' = compute FOURIER power, amp^2 =
    ' ================================
    DFPOW = (NUMACT - 1) * (DAMP2 - DFOURAMP2)
    DFPOW = DFPOW / (DVAR - DFOURAMP2) / 2
    DAMP = 2 * (DAMP2 - DFOURAMP2)
    IF DAMP < 0 THEN DAMP = 0
    DAMP = SQR(DAMP)
    END SUB

    SUB PROMPT (LABL$)
    ' **************
    ' * SUBROUTINE *
    ' *   prompt   *
    ' **************
    CLS 2
    LOCATE 19, 1
    IF LEN(FOVR$) < 5 THEN EXIT SUB
    OPEN "I", 6, FOVR$                  ' open overlay file
    NPRINT = 0
    DO UNTIL EOF(6)
        LINE INPUT #6, ZZ$
        LL$ = LEFT$(ZZ$, 4)
        IF LL$ = LABL$ THEN
            PRINT RIGHT$(ZZ$, LEN(ZZ$) - 4)
            NPRINT = NPRINT + 1
        ELSE
            IF NPRINT > 0 THEN GOTO PRODONE
        END IF
    LOOP
PRODONE:
    CLOSE 6                             ' close overlay file
    IF NPRINT < 7 THEN                  ' *if enough room then
        LOCATE 25, 1                    '   show statistical summary
        PRINT "N="; NUMACT;
        PRINT "   AVE=";
        PRINT USING "####.####"; DAVE;
        PRINT "   SDV=";
        PRINT USING "####.####"; DSIG;
        PRINT "   VAR=";
        PRINT USING "####.####"; DVAR;
    END IF                              ' *endif
    END SUB

    SUB RESOLVE (DDR, DDP)
    ' **************
    ' * SUBROUTINE *
    ' **************
    IF DDR = 0 THEN EXIT SUB
    NEXP = 0
    IF DDR < 1 THEN
        DO UNTIL DDR > 1
            DDR = DDR * 10
            NEXP = NEXP - 1
        LOOP
    ELSE
        DO UNTIL DDR < 10
            DDR = DDR / 10
            NEXP = NEXP + 1
        LOOP
    END IF
    SELECT CASE DDR
        CASE 1 TO 2
            DDR = 1
        CASE 2 TO 5
            DDR = 2
        CASE ELSE
            DDR = 5
    END SELECT
    DDR = DDR * 10 ^ NEXP
    DDP = DDP / DDR
    DDP = DDR * INT(DDP + .5)
    END SUB

    SUB SETGRAPH (XLO, XHI, YLO, YHI, XTIC)
    ' **************
    ' * SUBROUTINE *
    ' * setup graph*
    ' **************
    CLS 1
    IF XHI > XLO AND YHI > YLO THEN
        VIEW (0, 0)-(NXALL, NYALL)         ' viewport for plotting
        ' IF YLO <= -1 OR YHI > 20 THEN
            WINDOW (XLO, YLO)-(XHI, YHI)
        ' ELSE
        '     WINDOW SCREEN (XLO, YLO)-(XHI, YHI)
        ' END IF
    END IF
    LINE (XLO, YLO)-(XHI, YHI), 11, B
    IF XTIC > 0 THEN
        X1 = INT(XLO / XTIC + .99)
        X2 = INT(XHI / XTIC - .01)
        XSTEP = XTIC
    ELSE
        NT = INT(LOG(XHI - XLO) * TENLOG - .5)
        X1 = XLO / 10 ^ NT: X2 = XHI / 10 ^ NT
        X1 = 10 ^ NT * INT(X1 + .99)
        X2 = 10 ^ NT * INT(X2 - .01)
        XSTEP = 10 ^ NT
    END IF
    YY = (YHI - YLO) / 20
    FOR XX = X1 TO X2 STEP XSTEP
        LINE (XX, YLO)-(XX, YLO + YY), 11
        LINE (XX, YHI - YY)-(XX, YHI), 11
    NEXT XX
    X1 = 10 * INT(X1 / 10 + .99)
    X2 = 10 * INT(X2 / 10 - .01)
    FOR XX = X1 TO X2 STEP 10 * XSTEP
        LINE (XX, YLO)-(XX, YLO + YY), 12
        LINE (XX, YHI - YY)-(XX, YHI), 12
    NEXT XX
    PSET (XLO, YLO), 0
    END SUB

    SUB SETLIMIT
    ' **************
    ' * SUBROUTINE *
    ' * set limits *
    ' **************
    ' ==================================================
    ' = determine array number limits from time limits =
    ' ==================================================
    NLOLIM = 0: NUPLIM = 0
    FOR N = 1 TO NUMRAW
        IF TVEC(N) >= TLOLIM THEN GOTO GOTLOW
    NEXT N
GOTLOW:
    NLOLIM = N
    FOR N = NLOLIM TO NUMRAW
        IF TVEC(N) > TUPLIM THEN GOTO GOTUP
    NEXT N
GOTUP:
    NUPLIM = N - 1
    END SUB

    SUB SHOWBEST
    ' **************
    ' * SUBROUTINE *
    ' * show best  *
    ' * frequencies*
    ' **************
    CLS 2
    FMAT$ = "#####.####"
    FOR NQ = 1 TO 5
        IF DGPOWER(NQ) <> 0 THEN
            PRINT USING "#"; NQ;
            ' PRINT USING FREQFORM$; DGNU(NQ);
            PRINT USING FMAT$; DGPER(NQ);
            PRINT USING "####.##"; DGPOWER(NQ);
        END IF
        IF DGPOWER(NQ + 5) <> 0 THEN
            PRINT USING " ##"; NQ + 5;
            ' PRINT USING FREQFORM$; DGNU(NQ + 5);
            PRINT USING FMAT$; DGPER(NQ + 5);
            PRINT USING "####.##"; DGPOWER(NQ + 5);
        END IF
        IF DGPOWER(NQ + 10) <> 0 THEN
            PRINT USING " ##"; NQ + 10;
            PRINT USING FMAT$; DGPER(NQ + 10);
            PRINT USING "####.##"; DGPOWER(NQ + 10);
        END IF
        IF DGPOWER(NQ + 15) <> 0 THEN
            PRINT USING " ##"; NQ + 15;
            PRINT USING FMAT$; DGPER(NQ + 15);
            PRINT USING "####.##"; DGPOWER(NQ + 15);
        END IF
        PRINT
    NEXT NQ
    END SUB

    SUB SHOWRAW
    ' **************
    ' * SUBROUTINE *
    ' *  RAW plot  *
    ' **************
    VIEW PRINT
    WINDOW
    VIEW (0, 0)-(NXALL, NYALL), 0       ' viewport for plotting
    SETLIMIT                            ' set plotting index limits
    MAGSPAN = MHIGH - MLOW
    ' ======================================================
    ' = compute pixel numbers for left, right, top, bottom =
    ' ======================================================
    X = NWIDE * TLOLIM / TUPLIMIT
    NLEFT = NX0 + INT(X + .5)
    X = NWIDE * TUPLIM / TUPLIMIT
    NRIGHT = NX0 + INT(X + .5)
    X = NTALL * (MA - MLOW) / MAGSPAN
    NTOP = NY0 + INT(X + .5)
    X = NTALL * (MB - MLOW) / MAGSPAN
    NBOTTOM = NY0 + INT(X + .5)
    LINE (0, 0)-(NXALL, NX0 - 1), NOFF, BF
    LINE (0, NY1 + 1)-(NXALL, NYALL), NOFF, BF
    LINE (0, 0)-(NX0 - 1, NYALL), NOFF, BF
    LINE (NX1 + 1, 0)-(NXALL, NYALL), NOFF, BF
    ' ============================
    ' = show JD range bar at top =
    ' ============================
    LINE (NX0 - 1, 0)-(NX1 + 1, NY0 - 1), NOFF, BF
    LINE (NLEFT, 0)-(NRIGHT, NY0 - 1), NON, BF
    ' ==============================
    ' = show MAG range bar at left =
    ' ==============================
    LINE (0, NTOP)-(NX0 - 1, NBOTTOM), NON, BF
    ' ======================================
    ' = window parameters for entire view =
    ' ======================================
    XSTEP = TUPLIMIT / NWIDE
    YSTEP = (MHIGH - MLOW) / NTALL
    XLEFT = -NX0 * XSTEP
    XLEFT2 = -XSTEP
    XRIGHT = TUPLIMIT + (NXALL - NX1) * XSTEP
    XRIGHT2 = TUPLIMIT + XSTEP
    YTOP = MLOW - NY0 * YSTEP
    YTOP2 = MLOW - YSTEP
    YBOTTOM = MHIGH + (NYALL - NY1) * YSTEP
    YBOTTOM2 = MHIGH + YSTEP
    WINDOW SCREEN (XLEFT, YTOP)-(XRIGHT, YBOTTOM)
    ' ================================
    ' = tick marks for top time axis =
    ' ================================
    FOR XXX = 0 TO TUPLIMIT STEP TRESOLV
        LINE (XXX, YTOP2)-(XXX, YTOP), 15' place mark every TRESOLV day
    NEXT XXX
    'FF$ = STRING$(NDIGT, "#")
    NLAST = 0
    FOR XXX = 0 TO TUPLIMIT STEP TRESOLV
        X = 3 + 73 * XXX / TUPLIMIT
        NN = INT(X)
        IF NN < 1 THEN NN = 1
        IF NN > NLAST AND NN < 72 THEN
            X = DT0 + XXX
            LOCATE 2, NN
            XX$ = LTRIM$(STR$(X))
            XX$ = LEFT$(XX$, 4)
            PRINT XX$;
            NLAST = NN + 5
        END IF
    NEXT XXX
    ' ================================
    ' = tick marks for left mag axis =
    ' ================================
    TICKMAG = 1
    IF MHIGH - MLOW > 20 THEN
        X = MHIGH - MLOW
        X = LOG(X) * TENLOG
        X = INT(X - .5)
        X = 10 ^ X
        TICKMAG = X
    END IF
    FF$ = "###"
    FOR YYY = MLOW TO MHIGH STEP TICKMAG
        LINE (XLEFT, YYY)-(XLEFT2, YYY), 15  ' place mark at each 1 mag
        X = 14 * (YYY - MLOW) / MAGSPAN
        NN = INT(X) + 3
        IF NN > 2 AND NN < 18 THEN
            LOCATE NN, 1
            PRINT USING FF$; YYY;
        END IF
    NEXT YYY
    ' ======================================
    ' = window parameters for current view =
    ' ======================================
    XSTEP = (TUPLIM - TLOLIM) / NWIDE
    YSTEP = (MB - MA) / NTALL
    XLEFT = TLOLIM - NX0 * XSTEP
    XLEFT2 = TLOLIM - XSTEP
    XRIGHT = TUPLIM + (NXALL - NX1) * XSTEP
    XRIGHT2 = TUPLIM + XSTEP
    YTOP = MA - NY0 * YSTEP
    YTOP2 = MA - YSTEP
    YBOTTOM = MB + (NYALL - NY1) * YSTEP
    YBOTTOM2 = MB + YSTEP
    WINDOW SCREEN (XLEFT, YTOP)-(XRIGHT, YBOTTOM)
    ' ===================================
    ' = tick marks for bottom time axis =
    ' ===================================
    DTSPAN = TUPLIM - TLOLIM
    X = LOG(DTSPAN) * TENLOG            ' logten(timespan)
    X = INT(X - .6)                     ' int(that) - 1
    TICKJD = 10 ^ X                     ' time resolution for tick marks
    FOR XXX = TLOLIM TO TUPLIM STEP TICKJD
        LINE (XXX, YBOTTOM)-(XXX, YBOTTOM2), 15' place mark every 100 day
    NEXT XXX
    FF$ = "#######"
    NLAST = 8
    FOR XXX = TLOLIM TO TUPLIM STEP TICKJD
        X = 3 + 73 * (XXX - TLOLIM) / DTSPAN
        NN = INT(X)
        IF NN > NLAST AND NN < 70 THEN
            X = DT0 + XXX
            LOCATE 18, NN
            XX$ = LTRIM$(STR$(X))
            XX$ = RIGHT$(XX$, 4)
            PRINT XX$;
            NLAST = NN + 5
        END IF
    NEXT XXX
    ' =================================
    ' = tick marks for right mag axis =
    ' =================================
    TICKMAG = 1
    MAGSPAN = MB - MA
    IF MAGSPAN > 20 THEN
        X = LOG(MAGSPAN) * TENLOG
        X = INT(X - .5)
        X = 10 ^ X
        TICKMAG = X
    END IF
    FF$ = "###"
    YLOW = INT(MA + .9)
    FOR YYY = YLOW TO MB STEP TICKMAG
        LINE (XRIGHT, YYY)-(XRIGHT2, YYY), 15
        X = 14 * (YYY - MA) / MAGSPAN
        NN = INT(X) + 3
        IF NN > 2 AND NN < 18 THEN
            LOCATE NN, 78
            PRINT USING FF$; YYY;
        END IF
    NEXT YYY
    FOR N = NLOLIM TO NUPLIM
        BREAKOUT
        IF NBRAKE < 0 THEN EXIT SUB
        IF WVEC(N) <= 0 THEN
            PSET (TVEC(N), XVEC(N)), BAD
        ELSE
            PSET (TVEC(N), XVEC(N)), GOOD
        END IF
    NEXT N
    VIEW PRINT 1 TO 18
    LOCATE 1, 6: PRINT USING "#######"; DT0;
    LOCATE 1, 70: PRINT USING "#######"; TUPLIMIT + DT0;
    LOCATE 18, 1: PRINT USING "#######"; TLOLIM + DT0;
    LOCATE 18, 74: PRINT USING "#######"; TUPLIM + DT0;
    LOCATE 1, 32: PRINT FIN$;
    VIEW PRINT 19 TO 25                 ' viewport for text
    TCUR = (TLOLIM + TUPLIM) / 2        ' start cursor in midscreen
    MCUR = (MA + MB) / 2
    FMT2$ = "#######"
    NN = 3 - INT(LOG(DTSPAN) * TENLOG)  ' scale factor time axis
    IF NN > 0 THEN                      ' construct format string
        FMT2$ = FMT2$ + "."               '   to reflect accuracy
        FOR NA = 1 TO NN                '   of visual plot
            FMT2$ = FMT2$ + "#"
        NEXT NA
    END IF
    IF TMARK > 0 THEN
            NXMARK = PMAP(TMARK, 0)
            NYMARK = PMAP(MAGMARK, 1)
            TPUT = PMAP(NXMARK - 6, 2)
            MPUT = PMAP(NYMARK - 6, 3)
            IF TPUT >= TLOLIM AND TPUT <= TUPLIM THEN
                IF MPUT >= MA AND MPUT <= MB THEN
                    PUT (TPUT, MPUT), NYELLOW
                END IF
            END IF
    END IF
    END SUB

    SUB SMOOTH (DTIME, DMAG)
    ' **************
    ' * SUBROUTINE * Compute value of model function
    ' **************
    DT = (DTIME - DTZERO) / DTSCALE
    DMAG = DCOEF(0)
    FOR NP = 1 TO NPOLY
        DMAG = DMAG + DCOEF(NP) * DT ^ NP
    NEXT NP
    N2 = NPOLY
    FOR NF = 1 TO NFRE
        N2 = N2 + 2
        DPHASE = TWOPI * DFRE(NF) * DTSCALE * DT
        DMAG = DMAG + DCOEF(N2 - 1) * COS(DPHASE)
        DMAG = DMAG + DCOEF(N2) * SIN(DPHASE)
    NEXT NF
    END SUB

    SUB STATCOMP
    ' **************
    ' * SUBROUTINE *
    ' *  compute   * compute the basic statistics mean, variance,
    ' * statistics * st.dev., for the active window
    ' **************
    SETLIMIT
    NBRAKE = 0                          ' reset breakout flag
    NUMACT = 0: DWEIGHT = 0
    DAVE = 0: DVAR = 0
    DTAVE = 0: DTVAR = 0
    FOR N = NLOLIM TO NUPLIM
        IF WVEC(N) > 0 THEN
            NUMACT = NUMACT + 1
            DW = WVEC(N)
            DT = TVEC(N)
            DX = XVEC(N)
            DWEIGHT = DWEIGHT + DW
            DAVE = DAVE + DW * DX
            DVAR = DVAR + DW * DX ^ 2
            DTAVE = DTAVE + DT
            DTVAR = DTVAR + DT ^ 2
        END IF
    NEXT N
    IF NUMACT < 1 THEN
        DAVE = 0
        DVAR = 0
        DSIG = 0
        EXIT SUB
    END IF
    DAVE = DAVE / DWEIGHT
    DVAR = DVAR / DWEIGHT
    DVAR = DVAR - DAVE ^ 2              ' variance (based on N)
    IF DVAR < 0 THEN DVAR = 0
    DSIG = 0                            ' standard deviation
    IF NUMACT > 1 THEN DSIG = SQR(DVAR * NUMACT / (NUMACT - 1))
    ' ==================================
    ' = compute ave, var, sdev of time =
    ' ==================================
    DTAVE = DTAVE / NUMACT
    DTVAR = DTVAR / NUMACT - DTAVE ^ 2
    IF DTVAR < 0 THEN DTVAR = 0
    DTSIG = SQR(DTVAR)
    DTSPAN = TVEC(NUPLIM) - TVEC(NLOLIM)
    ' =============================
    ' = set scale factor for time =
    ' =============================
    IF DTSPAN <= 0 THEN EXIT SUB
    XX = LOG(DTSPAN) * TENLOG
    NX = INT(XX + .5)
    DTSCALE = 10 ^ NX
    DTS2 = 10 ^ (NX - 3)
    ' ===========================
    ' = set zero point for time =
    ' ===========================
    DTZERO = DTAVE / DTS2
    DTZERO = DTS2 * INT(DTZERO + .5)
    END SUB

    SUB TABLIT
    ' **************
    ' * SUBROUTINE *
    ' * good table *
    ' **************
    FOR NQ = 1 TO NBEST
        IF DLPOWER > DGPOWER(NQ) THEN
            FOR NQQ = NBEST - 1 TO NQ STEP -1
                DGPOWER(NQQ + 1) = DGPOWER(NQQ)
                DGNU(NQQ + 1) = DGNU(NQQ)
                DGPER(NQQ + 1) = DGPER(NQQ)
            NEXT NQQ
            DGPOWER(NQ) = DLPOWER: DGNU(NQ) = DLNU
            DGPER(NQ) = DLPER
            GOTO GOTGOOD
        END IF
    NEXT NQ
GOTGOOD:
    END SUB

    SUB ZOOMVIEW
    ' **************
    ' * SUBROUTINE *
    ' **************
    IF NZOOM = 0 THEN                   ' *if zoom then
        ' ================================
        ' = save current plotting limits =
        ' ================================
        MAZOOM = MA: MBZOOM = MB
        TLOZOOM = TLOLIM: TUPZOOM = TUPLIM
    END IF                              ' *endif
    DO
        MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
    LOOP UNTIL LBUT% = 0
    CLS 2
    IF YMOUSE < NY1 THEN
        IF MFLAG% < 0 THEN
            KSEL$ = F3$
            IF NZOOM < 0 THEN KSEL$ = ESC$
            GOTO ZOOMDIRECT
        END IF
    END IF
    PROMPT "ZOOM"
    MOUSESHOW                   ' show the mouse
    DO                          ' detect mouse state
        MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
    LOOP UNTIL KSEL$ <> NUL$ OR LBUT% < 0
    MOUSEHIDE
ZOOMDIRECT:
    SELECT CASE KSEL$
        ' ==============================
        CASE ESC$
            IF NZOOM < 0 THEN                   ' *if zoom BACK OUT then
                NZOOM = 0                       '   reset zoom-out flag
                MA = MAZOOM: MB = MBZOOM
                TLOLIM = TLOZOOM: TUPLIM = TUPZOOM
            END IF
        ' ==============================
        CASE F1$, F2$, F3$
            K2$ = KSEL$
            IF K2$ = F1$ OR K2$ = F2$ THEN
                CLS 2
                DO          ' detect mouse state
                    MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                LOOP UNTIL LBUT% = 0
                PROMPT "ZOO2"
                MOUSESHOW
                DO          ' detect mouse state
                    MOUSENOW LBUT%, RBUT%, MBUT%, XMOUSE, YMOUSE
                LOOP UNTIL LBUT% < 0
                MOUSEHIDE
            END IF
            TSPAN = (TUPLIM - TLOLIM) / 10
            MSPAN = (MB - MA) / 10
            TCUR = PMAP(XMOUSE, 2): MCUR = PMAP(YMOUSE, 3)
            TLOLIM = TCUR - TSPAN: TUPLIM = TCUR + TSPAN
            IF K2$ = F1$ THEN
                MA = MCUR - MSPAN: MB = MCUR + MSPAN
            END IF
            NZOOM = -1
            ' XMOUSE = 320: YMOUSE = 130
            ' IF MFLAG% THEN MOUSE 4, 0, XMOUSE, YMOUSE ' position mouse
    END SELECT
    STATCOMP
    SHOWRAW
    END SUB

